#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <queue>
#include <assert.h>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
const ll INF = (ll)1e18;
const double PI = acos(-1.0);

const int MAX_N = 105;
int n, m, d;
char A[MAX_N][MAX_N];

int main()
{
    //freopen(".in", "r", stdin);
    //freopen(".out", "w", stdout);
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    cin >> n >> m >> d;
    int x = -1, y = -1;
    for (int i = 0; i < n; i++)
    {
        for (int j = 0; j < m; j++)
        {
            cin >> A[i][j];
            if (A[i][j] == 'S')
            {
                A[i][j] = '.';
                x = i;
                y = j;
            }
        }
    }

    int q;
    cin >> q;
    int cnt = 0;
    char c;
    int dx = 0, dy = 0;
    int res = 0;
    while (q--)
    {
        cin >> c;
        if (c == 'R')
        {
            dx = 0;
            dy = 1;
        }
        else if (c == 'L')
        {
            dx = 0;
            dy = -1;
        }
        else if (c == 'U')
        {
            dx = -1;
            dy = 0;
        }
        else if (c == 'D')
        {
            dx = 1;
            dy = 0;
        }

        res = 0;
        while (true)
        {
            if (A[x][y] == 'K')
            {
                A[x][y] = '.';
                cnt++;
            }

            int nx = x + dx;
            int ny = y + dy;
            if (nx < 0 || nx >= n || ny < 0 || ny >= m || A[nx][ny] == '#')
            {
                break;
            }
            if (A[nx][ny] == 'L')
            {
                if (cnt == 0)
                {
                    break;
                }
                else
                {
                    cnt--;
                    A[nx][ny] = '.';
                }
            }

            x = nx;
            y = ny;
            res++;
        }

        cout << res << endl;
    }

    return 0;
}