#pragma gcc optimize("Ofast,unroll-loops")
#pragma gcc target("sse,sse2,sse3,ssse3,sse4,fma,mmx,avx,avx2,tune=native")
#include <iostream>
#include <iomanip>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
using namespace std;
typedef long long ll;
typedef long double ld;
#define sz(x) int(x.size())
#define dbg(x) cout << #x << " = " << x << '\n'
#define dbg1(x) cout << #x << " = [ "; for (auto& el : x) cout << el << ' '; cout << "]\n"
void solve() {
	ll n;
	cin >> n;
	map<ll, ll> mp;
	for (ll i = 2; i * i <= n; ++i) {
		if (n % i == 0) {
			ll cnt = 0;
			while (n % i == 0) {
				++cnt;
				n /= i;
			}
			mp[i] = cnt;
		}
	}
	if (n > 1) {
		++mp[n];
	}
	ll res = 1;
	for (auto& x : mp) res *= x.second + 1;
	cout << res << '\n';
}
signed main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout << fixed << setprecision(15);
	int t = 1;
	cin >> t;
	while (t--) solve();
}