#include<bits/stdc++.h>
using namespace std;
const long long INF = 1e9 + 10;
vector<set<int>> g;
map<int, string> dd;
vector<int> used;
string dfs(int v, int c) {
    used[v] = c;
    if (g[v].size() > 1) return "TOO COMPLEX";
    if (g[v].size() == 0) return dd[v];
    for (auto i : g[v]) {
        if (used[i] == c && i != v) return "INFINITE LOOP";
        if (i == v) return dd[v];
        return dfs(i, c);
    }
}
int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    int n;
    cin >> n;
    g.resize(200000);
    map<string, int> d;
    int ii = 0;
    for (int i = 0; i < n; i++) {
        string s, s1, s2;
        cin >> s >> s1 >> s2;
        if (d.find(s) == d.end()) {
            d[s] = ii;
            dd[ii] = s;
            ii++;
        }
        if (d.find(s2) == d.end()) {
            d[s2] = ii;
            dd[ii] = s2;
            ii++;
        }
        g[d[s]].insert(d[s2]);
    }
    used.resize(200000, 0);
    int q;
    cin >> q;
    for (int i = 1; i <= q; i++) {
        char t;
        string s1, s2;
        cin >> t >> s1;
        if (t == '+') {
            cin >> s2 >> s2;
            g[d[s1]].insert(d[s2]);
        } else {
            cout << dfs(d[s1], i) << "\n";
        }
    }
}

