#include <bits/stdc++.h>
using namespace std;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int h, w, d;
    cin >> h >> w >> d;
    vector<vector<int> > a(h, vector<int>(w));
    pair<int, int> now;
    for (int i = 0; i < h; ++i) {
        for (int j = 0; j < w; ++j) {
            char c;
            cin >> c;
            if (c == '.') {
                a[i][j] = 0;
            } else if (c == '#') {
                a[i][j] = 1;
            } else if (c == 'K') {
                a[i][j] = 2;
            } else if (c == 'S') {
                a[i][j] = 0;
                now.first = i;
                now.second = j;
            } else {
                a[i][j] = 3;
            }
        }
    }
    vector<set<pair<int, int> > > vert(w), gor(h);
    for (int i = 0; i < h; ++i) {
        for (int j = 0; j < w; ++j) {
            if (a[i][j] == 1) {
                gor[i].insert({j, 1});
            } else if (a[i][j] == 2) {
                gor[i].insert({j, 2});
            } else if (a[i][j] == 3) {
                gor[i].insert({j, 3});
            }
        }
    }
    for (int j = 0; j < w; ++j) {
        for (int i = 0; i < h; ++i) {
            if (a[i][j] == 1) {
                vert[j].insert({i, 1});
            } else if (a[i][j] == 2) {
                vert[j].insert({i, 2});
            } else if (a[i][j] == 3) {
                vert[j].insert({i, 3});
            }
        }
    }
    int test;
    cin >> test;
    int cnt = 0;
    for (int t = 0; t < test; ++t) {
        char c;
        cin >> c;
        if (c == 'R') {
            auto iter = gor[now.first].lower_bound({now.second, 0});
            vector<pair<int, int> > del;
            int ans = 0;
            while (true) {
                if (iter == gor[now.first].end()) {
                    ans = w - now.second - 1;
                    break;
                }
                pair<int, int> nw = *iter;
                ans = nw.first - 1 - now.second;
                if (nw.second == 2) {
                    cnt += 1;
                    del.push_back(nw);
                } else if (nw.second == 1) {
                    break;
                } else {
                    if (cnt == 0) {
                        break;
                    } else {
                        cnt -= 1;
                        del.push_back(nw);
                    }
                }
                iter++;
            }
            cout << ans << '\n';
            now.second += ans;
            for (int i = 0; i < del.size(); ++i) {
                gor[now.first].erase(del[i]);
                vert[del[i].first].erase({now.first, del[i].second});
            }
        } else if (c == 'L') {
            auto iter = gor[now.first].lower_bound({now.second, 0});
            vector<pair<int, int> > del;
            int ans = 0;
            if (iter != gor[now.first].begin()) {
                iter--;
            } else {
                ans = now.second;
            }
            while (ans != now.second) {
                if (iter == gor[now.first].begin()) {
                    pair<int, int> nw = *iter;
                    ans = now.second - 1 - nw.first;
                    if (nw.second == 2) {
                        cnt += 1;
                        del.push_back(nw);
                        ans = now.second;
                    } else if (nw.second == 1) {
                        break;
                    } else {
                        if (cnt == 0) {
                            break;
                        } else {
                            ans = now.second;
                            cnt -= 1;
                            del.push_back(nw);
                        }
                    }
                    break;
                }
                pair<int, int> nw = *iter;
                ans = now.second - 1 - nw.first;
                if (nw.second == 2) {
                    cnt += 1;
                    del.push_back(nw);
                } else if (nw.second == 1) {
                    break;
                } else {
                    if (cnt == 0) {
                        break;
                    } else {
                        cnt -= 1;
                        del.push_back(nw);
                    }
                }
                iter--;
            }
            cout << ans << '\n';
            now.second -= ans;
            for (int i = 0; i < del.size(); ++i) {
                gor[now.first].erase(del[i]);
                vert[del[i].first].erase({now.first, del[i].second});
            }
        }  else if (c == 'D') {
            auto iter = vert[now.second].lower_bound({now.first, 0});
            vector<pair<int, int> > del;
            int ans = 0;
            while (true) {
                if (iter == vert[now.second].end()) {
                    ans = h - now.first - 1;
                    break;
                }
                pair<int, int> nw = *iter;
                ans = nw.first - 1 - now.first;
                if (nw.second == 2) {
                    cnt += 1;
                    del.push_back(nw);
                } else if (nw.second == 1) {
                    break;
                } else {
                    if (cnt == 0) {
                        break;
                    } else {
                        cnt -= 1;
                        del.push_back(nw);
                    }
                }
                iter++;
            }
            cout << ans << '\n';
            now.first += ans;
            for (int i = 0; i < del.size(); ++i) {
                vert[now.second].erase(del[i]);
                gor[del[i].first].erase({now.second, del[i].second});
            }
        } else {
            auto iter = vert[now.second].lower_bound({now.first, 0});
            vector<pair<int, int> > del;
            int ans = 0;
            if (iter != vert[now.second].begin()) {
                iter--;
            } else {
                ans = now.first;
            }
            while (ans != now.first) {
                if (iter == vert[now.second].end()) {
                    pair<int, int> nw = *iter;
                    ans = now.first - 1 - nw.first;
                    if (nw.second == 2) {
                        cnt += 1;
                        ans = now.first;
                        del.push_back(nw);
                    } else if (nw.second == 1) {
                        break;
                    } else {
                        if (cnt == 0) {
                            break;
                        } else {
                            ans = now.first;
                            cnt -= 1;
                            del.push_back(nw);
                        }
                    }
                    break;
                }
                pair<int, int> nw = *iter;
                ans = now.first - 1 - nw.first;
                if (nw.second == 2) {
                    cnt += 1;
                    del.push_back(nw);
                } else if (nw.second == 1) {
                    break;
                } else {
                    if (cnt == 0) {
                        break;
                    } else {
                        cnt -= 1;
                        del.push_back(nw);
                    }
                }
                iter--;
            }
            cout << ans << '\n';
            now.first -= ans;
            for (int i = 0; i < del.size(); ++i) {
                vert[now.second].erase(del[i]);
                gor[del[i].first].erase({now.second, del[i].second});
            }
        }
    }
}