#include <iostream>
#include <vector>
#include <set>
#include <map>

using namespace std;

int k;
vector<vector<long long>> g, maxbval;
vector<long long> a, b, ans, razl;

void dfs(int v) {
    for (int i = 0; i < k && razl[i] <= a[v]; ++i) {
        maxbval[v][i] = b[v];
    }
    for (int u : g[v]) {
        dfs(u);
        for (int i = 0; i < k; ++i) {
            maxbval[v][i] = max(maxbval[v][i], maxbval[u][i]);
        }
    }
    for (int i = 0; i < k; ++i) {
        ans[v] += maxbval[v][i] * (razl[i] - (i == 0 ? 0ll : razl[i - 1]));
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;
    g.resize(n);
    a.resize(n);
    b.resize(n);
    ans.resize(n, 0);
    set<long long> vals;
    for (int i = 0; i < n; ++i) {
        int p;
        cin >> p >> a[i] >> b[i];
        vals.insert(a[i]);
        if (p != 0) {
            g[p - 1].emplace_back(i);
        }
    }
    for (auto it : vals) {
        razl.emplace_back(it);
    }
    k = razl.size();
    maxbval.resize(n, vector<long long>(k, 0));
    dfs(0);
    for (int i = 0; i < n; ++i) {
        cout << ans[i] << "\n";
    }

    return 0;
}
