#include<iostream>
#include<vector>
#include<algorithm>
#include<cmath>
#include<set>
#include<map>
#include<string>
using namespace std;

#define ll long long
#define all(a) a.begin(),a.end()

template<typename T>
istream& operator >>(istream& cin, vector<T>& v) {
	for (auto& i : v)
		cin >> i;
	return cin;
}

template<typename T>
ostream& operator <<(istream& cout, vector<T>& v) {
	for (auto& i : v)
		cout << i << ' ';
	return cout;
}

vector<vector<ll>> gr;
vector<ll> ans;
vector<set<pair<ll, ll>>> str;

void dfs(int v, int pr = 0) {
	for (auto& u : gr[v]) {
		if (u != pr)
			dfs(u, v);
		str[v].insert(all(str[u]));
	}

	ll cans = 0;
	ll maxy = 0;
	auto it = str[v].end();
	it--;
	while (true) {
		pair<ll, ll> cur = *it;
		if (cur.second > maxy) {
			cans += (cur.second - maxy)*cur.first;
			maxy = cur.second;
		}
		if (it == str[v].begin())
			break;
		it--;
	}
	ans[v] = cans;
}

int main() {
	int n;
	cin >> n;
	gr.resize(n);
	ans.resize(n);
	str.resize(n);

	for (int i = 0; i < n; i++) {
		ll p, x, y;
		cin >> p >> x >> y;
		str[i].insert({ x,y });
		p--;
		if(p >= 0)
			gr[p].push_back(i);
	}

	dfs(0);

	for (int i = 0; i < n; i++) {
		cout << ans[i] << '\n';
	}
	//system("pause");
}