//#define _GLIBCXX_DEBUG
#include <iostream>
#include <vector>
#include <algorithm>
#include <numeric>
#include <set>
#include <queue>
#include <stack>
#include <deque>
#include <map>
#include <iomanip>
#include <string>
#include <unordered_map>
#include <cstring>
#include <unordered_set>
#include <ctime>
#include <climits>
#include <cmath>

using namespace std;

//#define int long long
typedef long long ll;


signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    int n, m, d;
    cin >> n >> m >> d;
    vector<vector<char>> arr(n, vector<char>(m));
    int temp_i, temp_j;
    for (int i = 0; i < n; i++)
    {
        for (int j = 0; j < m; j++)
        {
            cin >> arr[i][j];
            if (arr[i][j] == 'S')
            {
                temp_i = i;
                temp_j = j;
            }
        }
    }
    vector<vector<int>> left_sten(n, vector<int>(m)), right_sten(n, vector<int>(m));
    vector<vector<int>> down_sten(n, vector<int>(m)), up_sten(n, vector<int>(m));
    for (int i = 0; i < n; i++)
    {
        for (int j = 0; j < m; j++)
        {
            if (arr[i][j] == '#')
                left_sten[i][j] = -1;
            else if (j == 0)
                left_sten[i][j] = 0;
            else
                left_sten[i][j] = left_sten[i][j - 1] + 1;
        }
        for (int j = m - 1; j >= 0; j--)
        {
            if (arr[i][j] == '#')
                right_sten[i][j] = -1;
            else if (j == m - 1)
                right_sten[i][j] = 0;
            else
                right_sten[i][j] = right_sten[i][j + 1] + 1;
        }
    }
    for (int j = 0; j < m; j++)
    {
        for (int i = 0; i < n; i++)
        {
            if (arr[i][j] == '#')
                up_sten[i][j] = -1;
            else if (i == 0) 
                up_sten[i][j] = 0;
            else
                up_sten[i][j] = up_sten[i - 1][j] + 1;
        }
        for (int i = n - 1; i >= 0; i--)
        {
            if (arr[i][j] == '#')
                down_sten[i][j] = -1;
            else if (i == n - 1)
                down_sten[i][j] = 0;
            else
                down_sten[i][j] = down_sten[i + 1][j] + 1;
        }
    }
    int ll;
    cin >> ll;
    string s;
    cin >> s;
    if (d == 0) {
        for(auto c : s) {
            if (c == 'R') {
                cout << right_sten[temp_i][temp_j] << '\n';
                temp_j += right_sten[temp_i][temp_j];
            }
            if (c == 'L') {
                cout << left_sten[temp_i][temp_j] << '\n';
                temp_j -= left_sten[temp_i][temp_j];
            }
            if (c == 'U') {
                cout << up_sten[temp_i][temp_j] << '\n';
                temp_i -= up_sten[temp_i][temp_j];
            }
            if (c == 'D') {
                cout << down_sten[temp_i][temp_j] << '\n';
                temp_i += down_sten[temp_i][temp_j];
            }
        }
        return 0;
    }
    int cnt_keys = 0;
    for(auto c: s) {
        if (c == 'R') {
            int gg = 0;
            while(true) {
                if (temp_j + 1 == m) break;
                if (arr[temp_i][temp_j + 1] == '#') break;
                if (arr[temp_i][temp_j + 1] == 'L' && cnt_keys == 0) break;
                gg++;
                if (arr[temp_i][temp_j + 1] == 'K') {
                    cnt_keys++;
                    arr[temp_i][temp_j + 1] = '.';
                }
                else if(arr[temp_i][temp_j + 1] == 'L') {
                    cnt_keys--;
                    arr[temp_i][temp_j + 1] = '.';
                }
                temp_j++;
            }
            cout << gg << '\n';
        }
        else if (c == 'L') {
            int gg = 0;
            while(true) {
                if (temp_j == 0) break;
                if (arr[temp_i][temp_j - 1] == '#') break;
                if (arr[temp_i][temp_j - 1] == 'L' && cnt_keys == 0) break;
                gg++;
                if (arr[temp_i][temp_j - 1] == 'K') {
                    cnt_keys++;
                    arr[temp_i][temp_j - 1] = '.';
                }
                else if(arr[temp_i][temp_j - 1] == 'L') {
                    cnt_keys--;
                    arr[temp_i][temp_j - 1] = '.';
                }
                temp_j--;
            }
            cout << gg << '\n';
        }
        else if (c == 'U') {
            int gg = 0;
            while(true) {
                if (temp_i == 0) break;
                if (arr[temp_i - 1][temp_j] == '#') break;
                if (arr[temp_i - 1][temp_j] == 'L' && cnt_keys == 0) break;
                gg++;
                if (arr[temp_i - 1][temp_j] == 'K') {
                    cnt_keys++;
                    arr[temp_i - 1][temp_j] = '.';
                }
                else if(arr[temp_i - 1][temp_j] == 'L') {
                    cnt_keys--;
                    arr[temp_i - 1][temp_j] = '.';
                }
                temp_i--;
            }
            cout << gg << '\n';
        }
        else {
            int gg = 0;
            while(true) {
                if (temp_i + 1 == n) break;
                if (arr[temp_i + 1][temp_j] == '#') break;
                if (arr[temp_i + 1][temp_j] == 'L' && cnt_keys == 0) break;
                gg++;
                if (arr[temp_i + 1][temp_j] == 'K') {
                    cnt_keys++;
                    arr[temp_i + 1][temp_j] = '.';
                }
                else if(arr[temp_i + 1][temp_j] == 'L') {
                    cnt_keys--;
                    arr[temp_i + 1][temp_j] = '.';
                }
                temp_i++;
            }
            cout << gg << '\n';
        }
        /*if (c == 'R') {
            int l = 0, r = right_sten[temp_i][temp_j];
            while(l + 1 < r) {
                int mid = (l + r) / 2;

            }
        }
        else if (c == 'L') {

        }
        else if (c == 'D') {

        }
        else {
            
        }*/
    }
}