//#define _GLIBCXX_DEBUG
#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
//#pragma GCC target("avx2")
#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef pair<int, int> ii;
typedef vector<int> vi;

const int INF = 1e9;

//#define int ll

map<string, set<string>> mm;
map<string, string> ans;

void build(string s) {
    if (ans.find(s) != ans.end()) return;
    if (mm[s].empty()) {
        ans[s] = s;
    }
    else {
        auto to = *(mm[s].begin());
        build(to);
        ans[s] = ans[to];
    }
}

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    int n;
    cin >> n;
    for (int i = 0; i < n; i++) {
        string a, is, c;
        cin >> a >> is >> c;
        mm[a].insert(c);
    }
    int q;
    cin >> q;
    if (n > 1000) {
        for(auto el: mm) {
            if (ans.find(el.first) == ans.end()) {
                build(el.first);
            }
        }
        while(q--) {
            string typ;
            cin >> typ;
            if (typ == "?") {
                string ss;
                cin >> ss;
                if(ans.find(ss) == ans.end()) {
                    cout << ss << '\n';
                    ans[ss] = ss;
                }
                else {
                    cout << ans[ss] << '\n';
                }
            }
            else {
                string a, is, c;
                cin >> a >> is >> c;
                if (ans.find(c) == ans.end()) {
                    ans[c] = c;
                }
                ans[a] = ans[c];
            }
        }
    }
    else {
        while (q--) {
            string typ;
            cin >> typ;
            if (typ == "?") {
                string st;
                cin >> st;
                queue<string> q;
                q.push(st);
                set<string> used;
                used.insert(st);
                while (!q.empty()) {
                    string v = q.front();
                    q.pop();
                    if (mm[v].size() >= 2) {
                        cout << "TOO COMPLEX\n";
                        goto xx;
                    }
                    if (mm[v].empty()) {
                        cout << v << '\n';
                        goto xx;
                    }
                    auto to = *(mm[v].begin());
                    if (to == v) {
                        cout << v << '\n';
                        goto xx;
                    }
                    if (used.find(to) == used.end()) {
                        used.insert(to);
                        q.push(to);
                    }
                    else {
                        cout << "INFINITE LOOP\n";
                        goto xx;
                    }
                }
                xx:;
            }
            else {
                string a, is, c;
                cin >> a >> is >> c;
                mm[a].insert(c);
            }
        }
    }
}