#include <bits/stdc++.h>

template<typename T>
void __read(T &a) { std::cin >> a; }

template<typename T, typename ... Args>
void __read(T &a, Args &... args) {
    std::cin >> a;
    __read(args...);
}

#define int long long
#define ld long double
#define VI std::vector<int>
#define VPI std::vector<PII>
#define VVI std::vector<VI>
#define PII std::pair<int, int>
#define f(n) for (int i = 0; i < n; i++)
#define FOR(i, n) for (int i = 0; i < n; i++)
#define make(t, ...) t __VA_ARGS__; __read(__VA_ARGS__)
#define makev(name, n) VI name(n); f(n) std::cin >> name[i]
#define makeVVI(name, n, m) VVI name(n, VI(m)); f(n) FOR(j, m) std::cin >> name[i][j]
#define ALL(q) q.begin(), q.end()
#define RALL(q) q.rbegin(), q.rend()

#define M7 1000000007
#define MFFT 998244353
#define INF 2000000000000000001
#define PI 3.14159265359

using namespace std;

void solve() {
    make(int, n, m, d);
    vector<string> s(n + 2);
    s[0] = s[n + 1] = string(m + 2, '#');
    f(n) {
        make(string, a);
        s[i + 1] = "#" + a + "#";
    }
    int x = 0;
    int y = 0;
    f(n) {
        FOR(j, m) {
            if (s[i + 1][j + 1] == 'S') {
                x = i + 1;
                y = j + 1;
                s[x][y] = '.';
                break;
            }
        }
        if (x != 0)
            break;
    }
    make(int, Q);
    make(string, T);
    int k = 0;
    for (char &c: T) {
        int q = 0;
        if (c == 'R') {
            while (true) {
                if (s[x][y + 1] == '#' || s[x][y + 1] == 'L' && k == 0) {
                    break;
                }
                y++;
                if (s[x][y] == 'K') {
                    s[x][y] = '.';
                    k++;
                } else if (s[x][y] == 'L') {
                    k--;
                    s[x][y] = '.';
                }
                q++;
            }
        } else if (c == 'L') {
            while (true) {
                if (s[x][y - 1] == '#' || s[x][y - 1] == 'L' && k == 0) {
                    break;
                }
                y--;
                if (s[x][y] == 'K') {
                    s[x][y] = '.';
                    k++;
                } else if (s[x][y] == 'L') {
                    k--;
                    s[x][y] = '.';
                }
                q++;
            }
        } else if (c == 'U') {
            while (true) {
                if (s[x - 1][y] == '#' || s[x - 1][y] == 'L' && k == 0) {
                    break;
                }
                x--;
                if (s[x][y] == 'K') {
                    s[x][y] = '.';
                    k++;
                } else if (s[x][y] == 'L') {
                    k--;
                    s[x][y] = '.';
                }
                q++;
            }
        } else {
            while (true) {
                if (s[x + 1][y] == '#' || s[x + 1][y] == 'L' && k == 0) {
                    break;
                }
                x++;
                if (s[x][y] == 'K') {
                    s[x][y] = '.';
                    k++;
                } else if (s[x][y] == 'L') {
                    k--;
                    s[x][y] = '.';
                }
                q++;
            }
        }
        cout << q << '\n';
    }

}

signed main(signed argc, char **argv) {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    if (argc > 1 && (string) argv[1] == "local") {
        freopen("output.txt", "w", stdout);
        freopen("input.txt", "r", stdin);
    }
    solve();
    return 0;
}