#include <bits/stdc++.h>

template<typename T>
void __read(T &a) { std::cin >> a; }

template<typename T, typename ... Args>
void __read(T &a, Args &... args) {
    std::cin >> a;
    __read(args...);
}

#define int long long
#define ld long double
#define VI std::vector<int>
#define VPI std::vector<PII>
#define VVI std::vector<VI>
#define PII std::pair<int, int>
#define f(n) for (int i = 0; i < n; i++)
#define FOR(i, n) for (int i = 0; i < n; i++)
#define make(t, ...) t __VA_ARGS__; __read(__VA_ARGS__)
#define makev(name, n) VI name(n); f(n) std::cin >> name[i]
#define makeVVI(name, n, m) VVI name(n, VI(m)); f(n) FOR(j, m) std::cin >> name[i][j]
#define ALL(q) q.begin(), q.end()
#define RALL(q) q.rbegin(), q.rend()

#define M7 1000000007
#define MFFT 998244353
#define INF 2000000000000000001
#define PI 3.14159265359

using namespace std;

int lcm(int a, int b) {
    return a * b / __gcd(a, b);
}

void solve() {
    make(int, n);
    makev(a, n);
    for (int &x: a) x++;
    VI lc(n);
    lc[0] = a[0];
    f(n - 1) lc[i + 1] = lcm(lc[i], a[i + 1]);
    make(int, T);
    while (T--) {
        make(int, b);
        b--;
        if (b % lc[n - 1] == 0) {
            cout << -1;
        } else {
            int l = -1;
            int r = n;
            while (r - l > 1) {
                int m = (l + r) / 2;
                if (b % lc[m] == 0) {
                    l = m;
                } else {
                    r = m;
                }
            }
            cout << r + 1;
        }
        cout << '\n';
    }





}

signed main(signed argc, char **argv) {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    if (argc > 1 && (string) argv[1] == "local") {
        freopen("output.txt", "w", stdout);
        freopen("input.txt", "r", stdin);
    }
    solve();
    return 0;
}