#include <iostream>
#include <set>
#include <algorithm>
#include <vector>
#include <random>
#include <ctime>
#include <map>
#include <unordered_map>

using namespace std;
#pragma GCC optimize("O3")

const int maxn = 5000;
long long n;
map<long long, long long> mas[maxn];
vector<long long> go[maxn];
long long mxa = -1;

long long readi() {
    long long x = 0;
    char c;
    while ((c = getchar()) >= '0' && c <= '9') {
        x = x * 10 + (c - '0');
    }
    return x;
}

void outpi(long long x) {
    if (x == 0) {
        putchar('0');
        return;
    }
    char buf[20];
    long long ln = 0;
    while (x) {
        buf[ln++] = x % 10 + '0';
        x = x / 10;
    }
    for (long long i = ln - 1; i >= 0; i--) {
        putchar(buf[i]);
    }
}

long long calc(long long cr) {
    long long crmx = 0;
    long long res = 0;
    long long crmxa = (--mas[cr].end())->first;
    for (long long i = crmxa; i >= 1; i--) {
        if (mas[cr].find(i) != mas[cr].end()) {
            crmx = max(crmx, mas[cr][i]);
        }
        res += crmx;
    }
    return res;
}

void dfs(long long cr) {
    for (long long to : go[cr]) {
        dfs(to);
        for (auto par : mas[to]) {
            mas[cr][par.first] = max(mas[cr][par.first], par.second);
        }
    }
}

signed main() {
    n = readi();
    for (int i = 0; i < n; i++) {
        mas[i] = map<long long, long long>();
        go[i] = vector<long long>();
    }
    for (long long i = 0; i < n; i++) {
        long long p, a, b;
        p = readi();
        a = readi();
        b = readi();
        mxa = max(mxa, a);
        mas[i][a] = max(mas[i][a], b);
        if (p) {
            go[p - 1].push_back(i);
        }
    }
    dfs(0);
    for (long long i = 0; i < n; i++) {
        outpi(calc(i));
        putchar('\n');
    }
    return 0;
}
