#include <iostream>
#include <set>
#include <algorithm>
#include <vector>
#include <random>
#include <ctime>

#pragma GCC optimize("O3")

using namespace std;

int readi() {
    int x = 0;
    char c;
    while ((c = getchar()) >= '0' && c <= '9') {
        x = x * 10 + (c - '0');
    }
    return x;
}

void outpi(int x) {
    if (x == 0) {
        putchar('0');
        return;
    }
    char buf[20];
    int ln = 0;
    while (x) {
        buf[ln++] = x % 10 + '0';
        x = x / 10;
    }
    for (int i = ln - 1; i >= 0; i--) {
        putchar(buf[i]);
    }
}

bool usd[10000500];

signed main() {
    int n = readi();
    vector<int> mas(n);
    for (int i = 0; i < 10000500; i++) usd[i] = false;
    vector<pair<int, int>> uniq;
    uniq.reserve(n);
    for (int i = 0; i < n; i++) {
        mas[i] = readi();
        mas[i]++;
        if (!usd[mas[i]]) uniq.push_back({i, mas[i]});
        usd[mas[i]] = true;
    }
    int q = readi();
    set<int> non;
    while (q--) {
        int v = readi();
        v--;
        if (non.find(v) != non.end()) {
            putchar('-');
            putchar('1');
            putchar('\n');
            continue;
        }
        bool f = false;
        for (int i = 0; i < uniq.size(); i++) {
            if (v % uniq[i].second != 0) {
                outpi(uniq[i].first + 1);
                putchar('\n');
                f = true;
                break;
            }
        }
        if (!f) {
            non.insert(v);
            putchar('-');
            putchar('1');
            putchar('\n');
        }
    }
    return 0;
}