#include <iostream>
#include <math.h>
#include <string>
using namespace std;

#define int long long
#define all(x) x.begin(), x.end()

const int maxn = 1e6 + 13;
const int INF = 2e18 + 13;



signed main(){
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	
	int h, w, d, n;
	string s;
	cin >> h >> w >> d;
	vector<vector<char>> a(h + 10, vector<int>(w + 10));
	int cx, cy;
	for(int i = 1; i <= h; ++i){
		for(int j = 1; j <= w; ++j){
			cin >> a[i][j];
			if(a[i][j] == 'S')cx = i, cy = j;
		}
	}
	cin >> n >> s;
	vector<vector<int>> left(h + 10, vector<int>(w + 10)),
					    right(h + 10, vector<int>(w + 10)),
					    up(h + 10, vector<int>(w + 10)),
					    down(h + 10, vector<int>(w + 10));
	for(int i = 1; i <= w; ++i)up[0][i] = 0;
	for(int i = 1; i <= h; ++i){
		for(int j = 1; j <= w; ++j){
			if(a[i][j] == '#')up[i][j] = i;
			else
				up[i][j] = up[i - 1][j];
		}
	}		   

	for(int i = 1; i <= w; ++i)down[h + 1][i] = h + 1;
	for(int i = h; i >= 1; --i){
		for(int j = 1; j <= w; ++j){
			if(a[i][j] == '#')down[i][j] = i;
			else down[i][j] = down[i + 1][j];
		}
	}

	for(int i = 1; i <= h; ++i)left[i][0] = 0;
	for(int j = 1; j <= w; ++j){
		for(int i = 1; i <= h; ++i){
			if(a[i][j] == '#')left[i][j] = j;
			else left[i][j] = left[i][j - 1];
		}
	}

	for(int i = 1; i <= h; ++i)right[i][w + 1] = w + 1;
	for(int j = w; j >= 1; --j){
		for(int i = 1; i <= h; ++i){
			if(a[i][j] == '#') right[i][j] = j;
			else right[i][j] = right[i][j + 1];
		}
	}

	if(d == 0){
		for(int i = 0; i < n; ++i){
			if(s[i] == 'U'){
				cout << up[cx][cy] - cx - 1 << "\n";
				cx = up[cx][cy] + 1;
			}else if(s[i] == 'D'){
				cout << cx - down[cx][cy] - 1 << "\n";
				cx = down[cx][cy] - 1;
			}else if(s[i] == 'L'){
				cout << cy - left[cx][cy] - 1 << "\n";
				cy = left[cx][cy] + 1;
			}else {
				cout << rihgt[cx][cy] - cy - 1 << "\n";
				cy = right[cx][cy] - 1;
			}
		}
	}else{
		return 0;
	}

	return 0;
}