#include <iostream>
#include <math.h>
#include <string>
#include <vector>
using namespace std;

#define int long long
#define all(x) x.begin(), x.end()

const int maxn = 1e6 + 13;
const int INF = 2e18 + 13;

vector<int> gr[maxn];
int a[maxn];
int b[maxn];
void dfs(int u, vector<int> &vv){
	vv.push_back(u);
	for(auto t : gr[u]){
		dfs(t, vv);
	}
}
signed main(){
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	
	int n;
	cin >> n;
	for(int i = 1; i <= n; ++i){
		int p;
		cin >> p >> a[i] >> b[i];
		gr[p].push_back(i);
	}
	for(int i = 1; i <= n; ++i){
		vector<int> v;
		dfs(i, v);
		int ca = 0, cb = 0;
		int ans = 0;
		for(int j = 0; j < v.size(); ++j){
			if(a[v[j]] > ca && b[v[j]] > cb)ans = a[v[j]] * b[v[j]], ca = a[v[j]], cb = b[v[j]];
			else{
				if(a[v[j]] > ca)ans += (a[v[j]] - ca) * b[v[j]], ca = a[v[j]];
				else if(b[v[j]] > cb) ans += (b[v[j]] - cb) * a[v[j]], cb = b[v[j]];
			} 
		}
		cout << ans << "\n";
	}
	return 0;
}