#include <iostream>
#include <vector>
#include <bitset>
#include <unordered_map>
#include <algorithm>
#include <map>
#include <set>
#include <cmath>
#include <stack>
#include <random>
#define int long long
using namespace std;
int h(string a){
    int res = 0;
    int k = 1;
    for (auto i : a){
        res += k*(i - 'A' + 1);
        k*=27;
    }
    return res;
}

string dh(int a){
    string res = "";
    while (a){
        res += (a%27-1+'A');
        a/=27;
    }
    return res;
}


void dfs(int v, vector<int> &p, vector<vector<int>> &g, vector<bool> &used, vector<int> &a, vector<int> &b, int i){
    if (g[v][a[i]] < b[i]){
        g[v][a[i]] = b[i];
        if (p[v] != -1)
            dfs(p[v], p, g, used, a, b, i);
    }
}


//#pragma GCC target ("avx2")
//#pragma GCC optimization ("O3")
//#pragma GCC optimization ("unroll-loops")
int32_t main() {
//    ios_base::sync_with_stdio(0);
//    cin.tie(0);
//    cout.tie(0);
    int n, ma = 0, mb = 0;
    cin >> n;
    vector<int> p(n), a(n), b(n);
    for (int i = 0; i < n; i++){
        cin >> p[i], p[i]-=1;
        cin >> a[i];
        ma = max(ma, a[i]);
        cin >> b[i];
        mb = max(mb, b[i]);
    }
    if (ma > mb)
        swap(a,b), swap(ma,mb);
    vector<vector<int>> g(n, vector<int> (ma+1));
    vector<bool> used(n);
    for (int i = n-1; i >= 0; i--)
            dfs(i, p, g, used, a, b, i);

//    for (auto i: g){
//        for (int j: i)
//            cout << j << ' ';
//        cout << endl;
//    }

    vector<int> res(n);
    int lm;
    for (int i = 0; i < n; i++){
        lm = 0;
        for (int j = ma; j >= 0; j--){
            if (g[i][j] > lm){
                res[i]+= j*(g[i][j]-lm);
                lm = g[i][j];
            }
        }
        cout << res[i] << endl;
    }
}
/*

 4
0 1 1
1 2 2
2 3 1
2 1 3

 3
BABA IS YOU
BOX IS KEY
KEY IS BOX
100
+ BABA IS YOU
? BABA
+ YOU IS YOU
? BABA
? BOX
+ BOX IS BOX
? BOX
? LOVE
 + LOVE IS LOVE
 ? LOVE

 */