#include <iostream>
#include <vector>
#include <queue>

using namespace std;
typedef long long ll;

void solve() {
    ll h, w, d;
    cin >> h >> w >> d;
    vector<string> mat(h);
    vector<vector<bool>> use(h);
    for (int i = 0; i < h; ++i) {
        cin >> mat[i];
        use[i].resize(w, false);
    }
    ll l;
    cin >> l;
    string s;
    cin >> s;
    bool peremena = false;
    if (d == 0) {
        peremena = false;
    } else {
        peremena = true;
    }
    ll kl = 0;
    ll x = -1, y = -1;
    for (int i = 0; i < h; ++i) {
        for (int j = 0; j < w; ++j) {
            if (mat[i][j] == 'S') {
                y = i;
                x = j;
            }
        }
    }

    for (int poz = 0; poz < l; ++poz) {
        ll cur = 0;

        if (s[poz] == 'R') {
            for (int i = x + 1; i < w; ++i) {
                if (mat[y][i] == '.' || mat[y][i] == 'S') {
                    cur++;
                    use[y][i] = true;
                } else if (mat[y][i] == '#') {
                    break;
                } else if (mat[y][i] == 'K') {
                    if (!use[y][i]) {
                        kl++;
                        use[y][i] = true;
                    }
                    cur++;
                } else if (mat[y][i] == 'L') {
                    if (!peremena) {
                        cur++;
                    } else {
                        if (!use[y][i]) {
                            if (kl != 0) {
                                kl--;
                                cur++;
                                use[y][i] = true;
                            } else {
                                break;
                            }
                        } else {
                            cur++;
                        }
                    }
                }
            }
            x += cur;
        } else if (s[poz] == 'L') {
            for (int i = x - 1; i >= 0; --i) {
                if (mat[y][i] == '.' || mat[y][i] == 'S') {
                    cur++;
                } else if (mat[y][i] == '#') {
                    break;
                } else if (mat[y][i] == 'K') {
                    if (!use[y][i]) {
                        kl++;
                        use[y][i] = true;
                    }
                    cur++;
                } else if (mat[y][i] == 'L') {
                    if (!peremena) {
                        cur++;
                    } else {
                        if (!use[y][i]) {
                            if (kl != 0) {
                                use[y][i] = true;
                                kl--;
                                cur++;
                            } else {
                                break;
                            }
                        } else {
                            cur++;
                        }
                    }
                }
            }
            x -= cur;
        } else if (s[poz] == 'U') {
            for (int i = y - 1; i >= 0; --i) {
                if (mat[i][x] == '.') {
                    cur++;
                } else if (mat[i][x] == '#') {
                    break;
                } else if (mat[i][x] == 'K') {
                    if (!use[i][x]) {
                        kl++;
                        use[i][x] = true;
                    }
                    cur++;
                } else if (mat[i][x] == 'L') {
                    if (!peremena) {
                        cur++;
                    } else {
                        if (!use[i][x]) {
                            if (kl != 0) {
                                use[i][x] = true;
                                kl--;
                                cur++;
                            } else {
                                break;
                            }
                        } else {
                            cur++;
                        }
                    }
                }
            }
            y -= cur;
        } else if (s[poz] == 'D') {
            for (int i = y + 1; i < h; ++i) {
                if (mat[i][x] == '.') {
                    cur++;
                } else if (mat[i][x] == '#') {
                    break;
                } else if (mat[i][x] == 'K') {
                    if (!use[i][x]) {
                        kl++;
                        use[i][x] = true;
                    }
                    cur++;
                } else if (mat[i][x] == 'L') {
                    if (!peremena) {
                        cur++;
                    } else {
                        if (!use[i][x]) {
                            if (kl != 0) {
                                use[i][x] = true;
                                kl--;
                                cur++;
                            } else {
                                break;
                            }
                        } else {
                            cur++;
                        }
                    }
                }
            }
            y += cur;
        }
        cout << cur << "\n";
    }
}

int main() {
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ll t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
}