#include <bits/stdc++.h>

using namespace std;

#define int long long
#define ALL(x) x.begin(), x.end()
#define RALL(x) x.rbegin(), x.rend()
#define makeVI(a, n) VI a (n); for (int i = 0; i < n; ++i) cin >> a[i];
#define makeVVI(a, n, m) VVI a (n, VI (m)); for (int i = 0; i < n; ++i) for (int j = 0; j < m; ++j) cin >> a[i][j];

#define M7 1000000007
#define M9 1000000009
#define INF 2000000000000000001
#define PI 3.14159265358979324

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int, int> PII;
typedef vector<int> VI;
typedef vector<PII> VPII;
typedef vector<VI> VVI;
typedef vector<VPII> VVPII;

int n;
VVI graf;
VPII a;
vector<map<int, int, greater<int>>> b;
void dfs (int v) {
    if (b[v].size() == 0) {
        b[v][a[v].first] = a[v].second;
        for (auto u: graf[v]) {
            dfs(u);
            for (auto p: b[u]) {
                b[v][p.first] = p.second;
            }
        }
    }
}

void solve()
{
    int Q;
    //cin >> Q;
    Q = 1;
    while (Q--) {
        cin >> n;
        graf.assign(n, VI());
        a.resize(n);
        b.resize(n);
        for (int i = 0; i < n; ++i) {
            int p, x, y;
            cin >> p >> x >> y;
            --p;

            a[i] = {x, y};
            if (p != -1) {
                graf[p].push_back(i);
            }
        }

        dfs(0);

        for (int i = 0; i < n; ++i) {
            int res = 0;
            PII mx = {0, 0};
            for (auto p: b[i]) {
                if (p.second > mx.second) {
                    res += p.first * (p.second - mx.second);
                    mx = p;
                }
            }
            cout << res << endl;
        }
    }
}

signed main(signed argc, char **argv)
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    if (argc > 1 && (string) argv[1] == "local") {
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    }
    solve();
}
