// #include "pch.h"


#include <iostream>
#include <fstream>
#include <vector>
#include <string>
#include <stack>
#include <queue>
#include <deque>
#include <cmath>
#include <set>
#include <map>
#include <algorithm>


using namespace::std;
int INF = 1e9 + 100;

int n;
vector<vector<int>>gr;
vector<pair<int, int>>v;

vector<int>kids;
int ans = 0;


void dfs(int v) {
	kids.push_back(v);
	for (auto &u : gr[v])
		dfs(u);
}



int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0), cout.tie(0);
	cout.setf(ios::fixed);
	cout.precision(10);


	int n;
	cin >> n;
	gr.resize(n);
	v.resize(n);
	for (int i = 0; i < n; i++) {
		int p;
		cin >> p >> v[i].first >> v[i].second;
		if (p != 0) gr[p - 1].push_back(i);
	}

	for (int i = 0; i < n; i++) {
		kids.clear();
		dfs(i);

		set<pair<int, int>>st;
		for (auto ind : kids) {
			for (int a = 1; a <= v[ind].first; a++)
				for (int b = 1; b <= v[ind].second; b++)
					st.insert({ a, b });
		}

		cout << st.size() << "\n";


	}


	return 0;
}
