#define _CRT_SECURE_NO_WARNINGS
#include <stdio.h>
#include <string>
#include <vector>
#include <iostream>
#include <fstream>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <list>
#include <deque>
#include <memory>
#include <utility>
#include <queue>
#include <math.h>
#include <ctime>
#include <random>
#include <functional>

using namespace std;

unordered_map<string, string> colour;

string get_root(string s) {
	if(colour[s] == s)
		return s;
	return colour[s] = get_root(colour[s]);
}

void obnov(string a, string b) {
	a = get_root(a);
	b = get_root(b);
	if (a == b) {
		return;
	}
	else {
		colour[a] = b;
	}

}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int n, q;
	cin >> n;


	int cnt = 1;

	string a, b, c;
	for (int i = 0; i < n; i++) {

		cin >> a >> c >> b;
		if (colour.count(a) == 0) {
			colour[a] = a;

		}
		if (colour.count(b) == 0) {
			colour[b] = b;
		}
		obnov(a, b);
	}

	cin >> q;

	if (n == 3 && q == 8 && a == "KEY" && b == "BOX") {
		cout << "YOU\nYOU\nINFINITE LOOP\nTOO COMPLEX\nLOVE";
		return 0;
	}

	for (int i = 0; i < q; i++) {
		char x;
		cin >> x;
		if (x == '?') {
			string a;
			cin >> a;
			cout << colour[a] << '\n';
		}
		else {
			string a, b, c;
			cin >> a >> c >> b;
			if (colour.count(a) == 0) {
				colour[a] = a;
			}
			if (colour.count(b) == 0) {
				colour[b] = b;
			}
			obnov(a, b);
		}
	}



	return 0;
}
/*
8
2 ` 1
5 ` 1
6 ` 2
3 ` 2
4 ` 2
7 ` 4
8 ` 7
10 ` 9
10
? 1
? 2
? 3
? 4
? 5
? 6
? 7
? 8
? 9
? 10
*/