#include <bits/stdc++.h>

using namespace std;

#define all(x) x.begin(), x.end()
#define endl '\n'
#define pb emplace_back
#define re return
#define rep(i, n) for (int i = 0; i < n; i++)

typedef pair<int, int> ii;
typedef long long ll;
typedef vector<string> vs;
typedef vector<ii> vii;

struct El
{
    int x, y;
    char type;
};

struct El2
{
    int x, y;
    char type;
};

bool operator< (El a, El b)
{
    re a.x < b.x || (a.x == b.x && a.y < b.y);
}

bool operator< (El2 a, El2 b)
{
    re a.y < b.y || (a.y == b.y && a.x < b.x);
}

void solve()
{
    int n, m, d, l, x, y, keys = 0;
    string t;
    cin >> n >> m >> d;
    vs f(n);
    set<El> r;
    set<El2> c;
    rep(i, n)
    {
        cin >> f[i];
        rep(j, m)
        {
            if (f[i][j] != '.') {
                if (f[i][j] == 'S') {
                    x = i;
                    y = j;
                }
                else {
                    r.insert(El{i, j, f[i][j]});
                    c.insert(El2{i, j, f[i][j]});
                }
            }
        }
    }
    cin >> l >> t;
    rep(i, l)
    {
        //cout << x << ' ' << y << endl;
        if (t[i] == 'U') {
            auto it = c.upper_bound(El2{x, y, char(1)});
            if (it == c.begin()) {
                cout << x << endl;
                x = 0;
                continue;
            }
            it--;
            if ((*it).y != y) {
                cout << x << endl;
                x = 0;
                continue;
            }
            El2 next = *it;
            if (next.type == 'K') {
                keys++;
                c.erase(it);
                r.erase(El{next.x, next.y, next.type});
                i--;
            }
            else if (next.type == '#') {
                cout << x - (next.x + 1) << endl;
                x = next.x + 1;
            }
            else {
                if (keys > 0 || d == 0) {
                    keys--;
                    c.erase(it);
                    r.erase(El{next.x, next.y, next.type});
                    i--;
                }
                else {
                    cout << x - (next.x + 1) << endl;
                    x = next.x + 1;
                }
            }
        }
        else if (t[i] == 'R') {
            auto it = r.upper_bound(El{x, y, char(1)});
            if (it == r.end() || (*it).x != x) {
                cout << (m - 1) - y << endl;
                y = m - 1;
                continue;
            }
            El next = *it;
            if (next.type == 'K') {
                keys++;
                r.erase(it);
                c.erase(El2{next.x, next.y, next.type});
                i--;
            }
            else if (next.type == '#') {
                cout << next.y - 1 - y << endl;
                y = next.y - 1;
            }
            else {
                if (keys > 0 || d == 0) {
                    keys--;
                    r.erase(it);
                    c.erase(El2{next.x, next.y, next.type});
                    i--;
                }
                else {
                    cout << next.y - 1 - y << endl;
                    y = next.y - 1;
                }
            }
        }
        else if (t[i] == 'D') {
            auto it = c.upper_bound(El2{x, y, char(1)});
            if (it == c.end() || (*it).y != y) {
                cout << (n - 1) - x << endl;
                x = n - 1;
                continue;
            }
            El2 next = *it;
            if (next.type == 'K') {
                keys++;
                c.erase(it);
                r.erase(El{next.x, next.y, next.type});
                i--;
            }
            else if (next.type == '#') {
                cout << next.x - 1 - x << endl;
                x = next.x - 1;
            }
            else {
                if (keys > 0 || d == 0) {
                    keys--;
                    c.erase(it);
                    r.erase(El{next.x, next.y, next.type});
                    i--;
                }
                else {
                    cout << next.x - 1 - x << endl;
                    x = next.x - 1;
                }
            }
        }
        else {
            auto it = r.upper_bound(El{x, y, char(1)});
            if (it == r.begin()) {
                cout << y << endl;
                y = 0;
                continue;
            }
            it--;
            if ((*it).x != x) {
                cout << y << endl;
                y = 0;
                continue;
            }
            El next = *it;
            if (next.type == 'K') {
                keys++;
                r.erase(it);
                c.erase(El2{next.x, next.y, next.type});
                i--;
            }
            else if (next.type == '#') {
                cout << y - (next.y + 1) << endl;
                y = next.y + 1;
            }
            else {
                if (keys > 0 || d == 0) {
                    keys--;
                    r.erase(it);
                    c.erase(El2{next.x, next.y, next.type});
                    i--;
                }
                else {
                    cout << y - (next.y + 1) << endl;
                    y = next.y + 1;
                }
            }
        }
    }
}

int main()
{
    ios::sync_with_stdio(0); cout.tie(0);
    int t = 1;
    //cin >> t;
    while (t--) solve();
    return 0;
}
