#include <iostream>
#include <iomanip>
#include <fstream>
#include <cstdio>
#include <sstream>
#include <cassert>
#include <vector>
#include <numeric>
#include <string>
#include <bitset>
#include <cmath>
#include <complex>
#include <algorithm>
#include <stack>
#include <queue>
#include <deque>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <random>
#include <chrono>
#include <ctime>

using namespace std;

#define en '\n'
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) (int)((x).size())

typedef unsigned int uint;
typedef long long ll;
typedef unsigned long long ull;
typedef __int128_t int128;
typedef double db;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef complex<long double> comp;

const int INF = 1e9 + 7;
const ll INFLL = 1e18;
const long double EPS = 1e-9;
const long double PI = 3.1415926535897932384626433832795;
//const long double PI = acos(-1);

mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count());

bool IS_ONE_TEST = 1;
ld START_TIME, TIME;

void fast_in_out() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

void solve() {
    ll n, a, b;
    cin >> n >> a >> b;
    ll one = 2 * (a + b);
    if (a == b) {
        ll two = one + b;
        ll cnt_2 = n / 2;
        ll ans = cnt_2 * one + b;
        if (n & 1) ans += one - a;
        cout << ans << en;
    }
    else if (b < a) {
        cout << one + (n - 1) * (one - b) << en;
    }
    else if (b <= 2 * a) {
        ll two = a + one;
        ll cnt_2 = n / 2;
        ll ans = two * cnt_2 - max(0LL, (cnt_2 - 1)) * b;
        if (n & 1) ans += one - b;
        cout << ans << en;
    }
}

int main() {
    START_TIME = clock();
    int TESTS = 1;
#ifdef __APPLE__
    TESTS = 2;
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    fast_in_out();
#endif
    if (!IS_ONE_TEST) cin >> TESTS;
    while (TESTS--) { solve(); }
#ifdef __APPLE__
    TIME = (clock() - START_TIME) / CLOCKS_PER_SEC;
    cerr << endl << TIME * 1000 << " ms." << endl;
#endif
    return 0;
}
