#include <algorithm>
#include <iostream>
#include <vector>
#include <stack>
#include <map>
#include <set>

using namespace std;

vector<vector<int>> f;

void psh(int x, int y) {

	for (int i = x - 2; i >= 0; --i) {
		f[i][y] ++;
	}
	for (int i = x + 2; i < f.size(); ++i) {
		f[i][y] ++;
	}
	for (int i = y - 2; i >= 0; --i) {
		f[x][i] ++;
	}
	for (int i = y + 2; i < f.size(); ++i) {
		f[x][i] ++;
	}
	for (int i = -1500; i <= 1500; ++i) {
		if (abs(i) < 2)
			continue;
		if (x - i >= 0 && x - i < f.size() && y - i >= 0 && y - i < f.size())
			f[x - i][y - i] ++;
		if (x - i >= 0 && x - i < f.size() && y + i >= 0 && y + i < f.size())
			f[x - i][y + i] ++;
	}
}

void solve() {
	int n, m, x, y, ans = 0;
	cin >> n >> m;
	f.assign(n, vector<int>(n, 0));
	vector<pair<int, int>> kings;
	for (int i = 0; i < m; ++i) {
		cin >> x >> y;
		kings.push_back(make_pair(x - 1, y - 1));
	}
	for (int i = 0; i < m; ++i) {
		psh(kings[i].first, kings[i].second);
	}
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < n; ++j) {
			if (f[i][j] == m)
				ans++;
		}
	}
	cout << ans << '\n';
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int t;
	cin >> t;
	while (t--)
		solve();

	return 0;
}