#include <bits/stdc++.h>

//#define int long long
#define pb push_back
#define all(x) (x).begin(), x.end()
#pragma comment(linker, "/STACK:66777216")

typedef long double ld;

using namespace std;

template<class A, class B> ostream& operator <<(ostream& out, const pair<A, B>& p) {
    return out << "(" << p.first << ", " << p.second << ")";
}
template<class A> ostream& operator <<(ostream& out, const vector<A>& v) {
    out << "[";
    for (int i = 0; i < v.size(); i++) {
        if (i) out << ", ";
        out << v[i];
    }
    return out << "]";
}

const int N = 1e5, T = 1e5 + 1, INF = 1e18, MOD = 1e9 + 7;

bool nice(int x, int y, int n, int m) {
    return 0 <= x && x < n && 0 <= y && y < m;
}

signed main() {
    ifstream cin("input.txt");
    ofstream cout("output.txt");
    ios::sync_with_stdio(0);
    cin.tie(0);


    int n, m, d;
    cin >> n >> m >> d;
    
    vector<vector<int>> f(n, vector<int>(m));
    //vector<vector<bool>> was(n, vector<bool>(m));
    vector<vector<int>> up(n, vector<int>(m, -1));
    vector<vector<int>> down(n, vector<int>(m, -1));
    vector<vector<int>> right(n, vector<int>(m, -1));
    vector<vector<int>> left(n, vector<int>(m, -1));

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            up[i][j] = i - 1;
            down[i][j] = i + 1;
            right[i][j] = j + 1;
            left[i][j] = j - 1;
        }
    }

    char t;
    pair<int, int> s;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> t;
            if (t == 'S')
                s = { i, j };
            else if (t == '#')
                f[i][j] = 1;
            else if (t == 'K')
                f[i][j] = 3;
            else if (t == 'L')
                f[i][j] = 2;
        }
    }
    int p, keys = 0;
    cin >> p;
    string L;
    cin >> L;
    if (1 || !d) {
        for (int i = 0; i < L.length(); i++) {
            pair<int, int> t = s;
            int res = 0;
            if (L[i] == 'R') {
                int x = s.first, y = s.second, prev = y;
                while (nice(x, y + 1, n, m)) {
                    if (f[x][y + 1] == 0 || f[x][y + 1] == 2 && keys > 0 || f[x][y + 1] == 3) {
                        if (f[x][y + 1] == 2) keys--;
                        else if (f[x][y + 1] == 3) keys++;
                        f[x][y + 1] = 0;
                        prev = y;
                        if (y == right[x][y])
                            n /= 0;
                        y = right[x][y];
                    }
                    else break;
                }
                for (int i = s.second; i <= prev; i++)
                    right[x][i] = y;
                s.second = y;
            }
            if (L[i] == 'L') {
                int x = s.first, y = s.second, prev = y;
                while (nice(x, y - 1, n, m)) {
                    if (f[x][y - 1] == 0 || f[x][y - 1] == 2 && keys > 0 || f[x][y - 1] == 3) {
                        if (f[x][y - 1] == 2) keys--;
                        else if (f[x][y - 1] == 3) keys++;
                        f[x][y - 1] = 0;
                        prev = y;
                        if (y == left[x][y])
                            n /= 0;
                        y = left[x][y];
                    }
                    else break;
                }
                for (int i = prev; i <= s.second; i++)
                    left[x][i] = y;
                s.second = y;
            }
            if (L[i] == 'D') {
                int x = s.first, y = s.second, prev = x;
                while (nice(x + 1, y, n, m)) {
                    if (f[x + 1][y] == 0 || f[x + 1][y] == 2 && keys > 0 || f[x + 1][y] == 3) {
                        if (f[x + 1][y] == 2) keys--;
                        if (f[x + 1][y] == 3) keys++;
                        f[x + 1][y] = 0;
                        prev = x;
                        if (x == down[x][y]) {
                            n /= 0;
                        }
                        x = down[x][y];
                    }
                    else break;
                }
                for (int i = s.first; i <= prev; i++)
                    down[i][y] = x;
                s.first = x;
            }
            if (L[i] == 'U') {
                int x = s.first, y = s.second, prev = x;
                while (nice(x - 1, y, n, m)) {
                    if (f[x - 1][y] == 0 || f[x - 1][y] == 2 && keys > 0 || f[x - 1][y] == 3) {
                        if (f[x - 1][y] == 2) keys--;
                        if (f[x - 1][y] == 3) keys++;
                        f[x - 1][y] = 0;
                        prev = x;
                        if (x == up[x][y]) {
                            n /= 0;
                        }
                        x = up[x][y];
                    }
                    else break;
                }
                for (int i = prev; i <= s.first; i++)
                    up[i][y] = x;
                s.first = x;
            }
            cout << abs(t.first - s.first) + abs(t.second - s.second) << '\n';
        }
    }
    else {
        for (int i = 0; i < L.length(); i++) {
            pair<int, int> t = s;
            int res = 0;
            if (L[i] == 'R') {
                int x = s.first, y = s.second, prev = y;
                while (nice(x, y + 1, n, m)) {
                    if (f[x][y + 1] == 0 || f[x][y + 1] == 2 && keys > 0 || f[x][y + 1] == 3) {
                        if (f[x][y + 1] == 2) keys--;
                        if (f[x][y + 1] == 3) keys++;
                        f[x][y + 1] = 0;
                        y++;
                    }
                    else break;
                }
                s.second = y;
            }
            if (L[i] == 'L') {
                int x = s.first, y = s.second, prev = y;
                while (nice(x, y - 1, n, m)) {
                    if (f[x][y - 1] == 0 || f[x][y - 1] == 2 && keys > 0 || f[x][y - 1] == 3) {
                        if (f[x][y - 1] == 2) keys--;
                        if (f[x][y - 1] == 3) keys++;
                        f[x][y - 1] = 0;
                        y--;
                    }
                    else break;
                }
                s.second = y;
            }
            if (L[i] == 'D') {
                int x = s.first, y = s.second, prev = x;
                while (nice(x + 1, y, n, m)) {
                    if (f[x + 1][y] == 0 || f[x + 1][y] == 2 && keys > 0 || f[x + 1][y] == 3) {
                        if (f[x + 1][y] == 2) keys--;
                        if (f[x + 1][y] == 3) keys++;
                        f[x + 1][y] = 0;
                        x++;
                    }
                    else break;
                }
                s.first = x;
            }
            if (L[i] == 'U') {
                int x = s.first, y = s.second, prev = x;
                while (nice(x - 1, y, n, m)) {
                    if (f[x - 1][y] == 0 || f[x - 1][y] == 2 && keys > 0 || f[x - 1][y] == 3) {
                        if (f[x - 1][y] == 2) keys--;
                        if (f[x - 1][y] == 3) keys++;
                        f[x - 1][y] = 0;
                        x--;
                    }
                    else break;
                }
                s.first = x;
            }
            cout << abs(t.first - s.first) + abs(t.second - s.second) << '\n';
        }
    }
}