#include <bits/stdc++.h>

#define int long long
#define pb push_back
#define all(x) (x).begin(), x.end()
#pragma comment(linker, "/STACK:66777216")

typedef long double ld;

using namespace std;

template<class A, class B> ostream& operator <<(ostream& out, const pair<A, B>& p) {
    return out << "(" << p.first << ", " << p.second << ")";
}
template<class A> ostream& operator <<(ostream& out, const vector<A>& v) {
    out << "[";
    for (int i = 0; i < v.size(); i++) {
        if (i) out << ", ";
        out << v[i];
    }
    return out << "]";
}

const int N = 1e5, T = 1e5 + 1, INF = 1e18, MOD = 1e9 + 7;

vector<vector<int>> f;
vector<int> a, b, dp;
int V;

void dfs(int v, int p = -1) {
    if (a[v] >= V) dp[v] = b[v];
    for (int to : f[v]) {
        if (to == p) continue;
        dfs(to, v);
        dp[v] = max(dp[v], dp[to]);
    }
}

signed main() {
    ifstream cin("input.txt");
    ofstream cout("output.txt");
    ios::sync_with_stdio(0);
    cin.tie(0);

    int n;
    cin >> n;
    f.resize(n);
    a.resize(n);
    b.resize(n);
    dp.resize(n);
    int p, A = 0;
    for (int i = 0; i < n; i++) {
        cin >> p >> a[i] >> b[i];
        A = max(A, a[i]);
        p--;
        if (p >= 0) {
            f[i].pb(p);
            f[p].pb(i);
        }
    }
    vector<int> ans(n);
    for (int i = 1; i <= A; i++) {
        V = i;
        dp.assign(n, 0);
        dfs(0);
        for (int j = 0; j < n; j++)
            ans[j] += dp[j];
    }
    for (int i = 0; i < n; i++)
        cout << ans[i] << '\n';
}