#include<iostream>
#include<cmath>
#include<algorithm>
#include<vector>
#include<set>
#include<map>

using namespace std;

typedef long long ll;
 
map<string, set<string>> g;
set<string>used;

string dfs(string v) {
    used.insert(v);
    
    if (g[v].size() > 1) {
        return "TOO COMPLEX";
    }
    if (g[v].empty())
        return v;
    if (g[v].size() == 1 && *(g[v].begin()) == v) {
        return v;
    }
    if (used.find(*(g[v].begin())) != used.end() && *(g[v].begin()) != v) {
        return "INFINITE LOOP";
    }
    return dfs(*(g[v].begin()));
    
}

void solve() {
    int n;
    cin >> n;
    
    
    string x, y, op;
    for (int i = 0; i < n; i++) {
        cin >> x >> op >> y;
        g[x].insert(y);
    }
    int q;
    cin >> q;
    while (q--) {
        char t;
        cin >> t;
        if (t == '+') {
            cin >> x >> op >> y;
            g[x].insert(y);
        }
        else {
            cin >> x;
            used.clear();
            cout << dfs(x)<< "\n";
            
        }
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    /*int t;
    cin >> t;
    while (t--)*/
        solve();
    return 0;
}
