#include<iostream>
#include<cmath>
#include<algorithm>
#include<vector>
#include<set>
#include<map>

using namespace std;

typedef long long ll;
 
map<string, set<string>> g;
set<string>used;
map<string, string> ans;
set<string> mn;
map<string, string>pr;

string get(string v) {
    if (pr[v] == v) {
        return v;
    }
    return pr[v] = get(pr[v]);
}

void un(string x, string y) {
    x = get(x);
    y = get(y);
    pr[y] = x;
    ans[x] = ans[y];
}

string dfs(string v) {
    used.insert(v);
    
    if (g[v].size() > 1) {
        return "TOO COMPLEX";
    }
    if (g[v].empty())
        return v;
    if (g[v].size() == 1 && *(g[v].begin()) == v) {
        return v;
    }
    if (used.find(*(g[v].begin())) != used.end() && *(g[v].begin()) != v) {
        return "INFINITE LOOP";
    }
    return dfs(*(g[v].begin()));
    
}

void solve() {
    int n;
    cin >> n;
    set<int> a;
    int x;
    for (int i = 0; i < n; i++) {
        cin >> x;
        a.insert(x);
    }
    int q;
    cin >> q;
    vector<int> ans(q);
    set<pair<int, int>>s;
    for (int i = 0; i < q; i++) {
        cin >> x;
        s.insert({ x, i });
    }
    for (auto v : a) {
        vector<pair<int, int>>d;
        for (auto u : s) {
            if (u.first % (v+1) != 1) {
                d.push_back(u);
                ans[u.second] = v;
            }
            
        }
        for (auto u : d) {
            s.erase(u);
        }
    }
    for (auto u : ans) {
        if (u == 0)
            cout << -1 << "\n";
        else 
            cout << u << "\n";
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    /*int t;
    cin >> t;
    while (t--)*/
        solve();
    return 0;
}
