#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define fastio ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0)
#define sz(v) (int)(v).size()

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> indexed_set;

const ll INF = ll(2e9) + 100100, LINF = ll(1e18) + 100100;
const double EPS = 1e-9, PI = atan2(0.0, -1.0);
const int MODS[] = {signed(1e9) + 7, signed(1e9) + 9, 998244353};
const int PS[] = {117, 239, signed(1e5) + 3, 177013};
const int MAXN = signed(1e5) + 100, MAXLOG = 20;

mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count());

inline void solve() {
    ll n; cin >> n;

    if (n == 1) {
        cout << "1\n";
        return;
    }

    ll left = 0, right = ll(1e9) + 1;

    while (right - left > 1) {
        ll mid = (left + right) / 2;

        if (mid * (4 + mid - 1) >= n - 1) right = mid;
        else left = mid;
    }

    ll block = right;
    ll add = 1 + block, fir = 2 * block;
    ll passed = 1 + (block - 1) * (4 + block - 2);

    if (passed + add >= n) cout << fir << "\n";
    else cout << fir + 1 << "\n";
}

signed main() {
    fastio;
#ifdef hikki
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int q; cin >> q;
    while (q--) solve();    

    return 0;
}