#include <iostream>
#include <algorithm>

#define maxM 1000

long long t, m, n, x, y, table[maxM][maxM];

int main() {
	std::cin >> t;
	for (long long i = 0; i < t; i++) {
		long long ans = 0;
		std::cin >> m >> n;
		for (long long j = 0; j < n; j++) {
			for (long long h = 0; h < n; h++) {
				table[j][h] = 0;
			}
		}
		for (long long j = 1; j <= n; j++) {
			ans = 0;
			std::cin >> x >> y; --x; --y;
			for (long long h = 0; h < x - 1; h++) {
				table[h][y]++;
				if (table[h][y] == j) {
					ans++;
				}
			}
			for (long long h = x + 2; h < m; h++) {
				table[h][y]++;
				if (table[h][y] == j) {
					ans++;
				}
			}
			for (long long h = 0; h < y - 1; h++) {
				table[x][h]++;
				if (table[x][h] == j) {
					ans++;
				}
			}
			for (long long h = y + 2; h < m; h++) {
				table[x][h]++;
				if (table[x][h] == j) {
					ans++;
				}
			}
			for (long long h = 2; h <= std::min(x, y); h++) {
				table[x - h][y - h]++;
				if (table[x - h][y - h] == j) {
					ans++;
				}
			}
			for (long long h = 2; h <= std::min(m - x - 1, y); h++) {
				table[x + h][y - h]++;
				if (table[x + h][y - h] == j) {
					ans++;
				}
			}
			for (long long h = 2; h <= std::min(m - x - 1, m - y - 1); h++) {
				table[x + h][y + h]++;
				if (table[x + h][y + h] == j) {
					ans++;
				}
			}
			for (long long h = 2; h <= std::min(x, m - y - 1); h++) {
				table[x - h][y + h]++;
				if (table[x - h][y + h] == j) {
					ans++;
				}
			}
			if (ans == 0) {
				j++;
				while (j <= n) {
					std::cin >> x >> y;
					j++;
				}
				break;
			}
		}
		std::cout << ans << std::endl;
	}
	return 0;
}