#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>

using namespace std;

typedef long long ll;
typedef long double ld;

const int INF = 1e9 + 7;
const int N = 2e7;



void Solve() {
	int n; cin >> n;
	vector <bool> used(N);
	vector <int> ans(N, INF);
	vector <int> vals;
	for (int i = 0; i < N; i++)
		vals.push_back(i);
	for (int i = 0; i < n; i++) {
		int q;
		cin >> q;
		q++;
		if (used[q]) continue;
		used[q] = true;
		vector <int> nxt;
		for (auto j : vals) {
			if (j % q == 0) nxt.push_back(j);
			else ans[j] = i + 1;
		}
		vals = nxt;
	}
	cin >> n;
	for (int i = 0; i < n; i++) {
		int q;
		cin >> q;
		q--;
		if (ans[q] == INF) cout << "-1\n";
		else cout << ans[q] << "\n";
	}

}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(false);
	Solve();
}