#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>

using namespace std;

typedef long long ll;
typedef long double ld;

const int INF = 1e9 + 7;
const int N = 1.1e7;

ll gcd(ll a, ll b) {
	while (b) {
		a %= b;
		swap(a, b);
	}
	return a;
}

void Solve() {
	ll n, a, b;
	cin >> n >> a >> b;
	ll inOneTime = b / a + 1;
	ll fullTimes = n / inOneTime;
	ll togo = n - inOneTime * fullTimes;
	ll timeForFull = fullTimes * ((2 * a + b) + (inOneTime - 1) * a);

	if (togo == 0) {
		cout << timeForFull + b;
	}
	else {
		cout << timeForFull + (2 * a + b) + (togo - 1) * a + b;
	}
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(false);
	Solve();
}