#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <algorithm>
#include <cmath>
#include <string>
#include <sstream>
#include <vector>
#include <stack>
#include <queue>
#include <deque>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <iomanip>
#include <functional>
#include <limits>
#include <ctime>
#include <cassert>

#define pb push_back
#define mp make_pair
#define endl '\n'
#define sqr(x) ((x) * (x))
#define IOboost ios_base::sync_with_stdio(false); cin.tie(NULL)
#ifndef _getchar_nolock
#define _putchar_nolock putchar_unlocked
#define _getchar_nolock getchar_unlocked
#endif
#define int ll

#pragma warning (disable : 4996)
#pragma optimize ("gtsy", on)
//#pragma comment(linker, "/STACK:536870912")

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair <int, int> pii;
typedef vector <int> vi;
typedef vector <vi> vvi;
typedef vector <pii> vii;
typedef vector <char> vc;

const ld EPS = 1e-8;
const int N = (int)1e5 + 10;
const int INF = (int)2e9;
const int MOD = (int)1e9 + 7;

int gcd(int a, int b) {
	if (!b)
		return a;
	return gcd(b, a % b);
}

signed main() {
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	IOboost;

	int n;
	cin >> n;
	vi a(n);
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
		++a[i];
	}
	vi p(n + 1);
	p[0] = 1;
	for (int i = 0; i < n; ++i)
		p[i + 1] = p[i] * a[i] / gcd(p[i], a[i]);
	int q;
	cin >> q;
	for (int i = 0; i < q; ++i) {
		int x;
		cin >> x;
		--x;
		int l = 0, r = n + 1;
		while (r - l > 1) {
			int m = (l + r) / 2;
			if (x % p[m] == 0)
				l = m;
			else
				r = m;
		}
		if (r == n + 1)
			cout << -1 << endl;
		else
			cout << r << endl;
	}

	return 0;
}