#pragma gcc optimize("Ofast,no-stack-protector,tune=native")
#pragma gcc optimize("sse,sse2,sse3,sse4,ssse3")
#pragma gcc optimize("abm,mmx,avx,avx2,unroll-loops,fast-math,section-anchors")

#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const ll INF = (ll)(1e18);
const ll MOD = (ll)(1e9 + 7);
const ld EPS = (ld)(1e-18);

void fast_stream() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    //cout << fixed << setprecision(30);
}

vector<set<pair<ll, ll>>> a;
vector<vector<ll>> g;
vector<pair<ll, ll>> a_and_b;
vector<ll> ans;

void dfs(ll v) {
    // cout << v << endl;
    for (auto i : g[v]) {
        dfs(i);
        for (auto j : a[i]) {
            a[v].insert(j);
        }
    }
    for (ll i = 1; i <= a_and_b[v].first; ++i) {
        for (ll j = 1; j <= a_and_b[v].second; ++j) {
            a[v].insert({i, j});
        }
    }
    return;
}

signed main() {
    fast_stream();
    //freopen("avia.in", "r", stdin);
    //freopen("avia.out", "w", stdout);
    ll n;
    cin >> n;
    g.resize(n);
    a_and_b.resize(n);
    ans.resize(n);
    a.resize(n);
    for (ll i = 0; i < n; ++i) {
        ll nach, x, y;
        cin >> nach >> x >> y;
        a_and_b[i] = {x, y};
        if (nach == 0) {
            continue;
        }
        g[nach - 1].push_back(i);
    }
    dfs(0LL);
    for (ll i = 0; i < n; ++i) {
        cout << a[i].size() << '\n';
    }
}