#include <bits/stdc++.h>

using namespace std;

//#define double long double
//#define int long long

struct Point{
    int u,r,d,l;
    Point(int u,int r,int d,int l):u(u),r(r),d(d),l(l){};
};

vector<vector<char> > g;
int x,y;
int ans=0,cnt=0;

void f(char t){
//    cout<<"CHECK "<<x<<" "<<y<<endl;

    if(g[x][y]=='K'){
        cnt++;
        g[x][y]='.';
    }else if(g[x][y]=='L'){
        cnt--;
        if(cnt>=0)
            g[x][y]='.';

    }
    if(g[x][y]=='#'||cnt<0){
        if(t=='U'){
            x++;
        }else if(t=='R'){
            y--;
        }else if(t=='D'){
            x--;
        }else if(t=='L'){
            y++;
        }
        if(cnt<0)
            cnt=0;
        return;
    }

    ans++;
    if(t=='U'){
        x--;
    }else if(t=='R'){
        y++;
    }else if(t=='D'){
        x++;
    }else if(t=='L'){
        y--;
    }
    f(t);
}

signed main() {
    ios::ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int h,w,d;
    cin>>h>>w>>d;

    g.resize(h+2,vector<char> (w+2,'#'));
    for(int i=0;i<w+2;i++){
        g[0][i]='#';
        g[h+1][i]='#';
    }

    for(int i=0;i<h;i++){
        for(int j=0;j<w;j++){
            cin>>g[i+1][j+1];
            if(g[i+1][j+1]=='S'){
                x=i+1;y=j+1;
            }
        }
    }

    int q;
    cin>>q;

    string s;
    cin>>s;

    if(d==0){
        vector<vector<Point> > dp(h+2,vector<Point> (w+2,Point(0,0,0,0)));

        vector<vector<vector<int> > > k(4,vector<vector<int> > (h+2,vector<int> (w+2,0)))
        ,l(4,vector<vector<int> > (h+2,vector<int> (w+2,0)));

        for(int i=1;i<=h;i++){
            for(int j=1;j<=w;j++){
                if(g[i][j]=='K') {
                    k[0][i][j] = k[0][i-1][j] + 1;
                    k[3][i][j] = k[3][i][j-1] + 1;
                }else{
                    k[0][i][j] = k[0][i-1][j];
                    k[3][i][j] = k[3][i][j-1];
                }

                if(g[i][j]=='L') {
                    l[0][i][j] = l[0][i-1][j] + 1;
                    l[3][i][j] = l[3][i][j-1] + 1;
                }else{
                    l[0][i][j] = l[0][i-1][j];
                    l[3][i][j] = l[3][i][j-1];
                }
                
                if(g[i][j]=='#'){
                    dp[i][j]=Point(0,0,0,0);
                }else{
                    dp[i][j].u=dp[i-1][j].u+1;
                    dp[i][j].l=dp[i][j-1].l+1;
                }
            }
        }
        
        for(int i=h;i>=1;i--){
            for(int j=w;j>=1;j--){
                if(g[i][j]=='K') {
                    k[2][i][j] = k[2][i+1][j] + 1;
                    k[1][i][j] = k[1][i][j+1] + 1;
                }else{
                    k[2][i][j] = k[2][i+1][j];
                    k[1][i][j] = k[1][i][j+1];
                }

                if(g[i][j]=='L') {
                    l[2][i][j] = l[2][i+1][j] + 1;
                    l[1][i][j] = l[1][i][j+1] + 1;
                }else{
                    l[2][i][j] = l[2][i+1][j];
                    l[1][i][j] = l[1][i][j+1];
                }

                if(g[i][j]=='#'){
                    dp[i][j]=Point(0,0,0,0);
                }else{
                    dp[i][j].d=dp[i+1][j].d+1;
                    dp[i][j].r=dp[i][j+1].r+1;
                }
            }
        }

        int cnt=0;
        for(int i=0;i<q;i++){
            if(s[i]=='U'){
                int x2=x-dp[x][y].u-1;
                
                int left=0,right=x2;
                while(left+1<right){
                    int mid=(left+right)/2;
                    
                    int cnt_k=k[2][x-mid][y]-k[2][x+1][y];
                    int cnt_l=l[2][x-mid][y]-l[2][x+1][y];
                    if(cnt_k+cnt-cnt_l>=0){
                        left=mid;
                    }else{
                        right=mid;
                    }
                }
                
                x+=left;
                cnt+=k[2][x-left][y-left]-k[2][x+1][y];
                cout<<left<<endl;
            }else if(s[i]=='R'){
                int y2=y+dp[x][y].r-1;

                int left=0,right=y2;
                while(left+1<right){
                    int mid=(left+right)/2;

                    int cnt_k=k[3][x][y+mid]-k[3][x][y-1];
                    int cnt_l=l[3][x][y+mid]-l[3][x][y-1];
                    if(cnt_k+cnt-cnt_l>=0){
                        left=mid;
                    }else{
                        right=mid;
                    }
                }

                x+=left;
                cnt+=k[3][x][y+left]-k[3][x][y-1];
                cout<<left<<endl;
            }else if(s[i]=='D'){
                int x2=x+dp[x][y].d-1;

                int left=0,right=x2;
                while(left+1<right){
                    int mid=(left+right)/2;

                    int cnt_k=k[0][x+mid][y]-k[0][x-1][y];
                    int cnt_l=l[0][x+mid][y]-l[0][x-1][y];
                    if(cnt_k+cnt-cnt_l>=0){
                        left=mid;
                    }else{
                        right=mid;
                    }
                }

                cnt+=k[0][x+left][y]-k[0][x-1][y];
                x+=left;
                cout<<left<<endl;
            }else{
                int y2=y-dp[x][y].l-1;

                int left=0,right=y2;
                while(left+1<right){
                    int mid=(left+right)/2;

                    int cnt_k=k[1][x][y-mid]-k[1][x][y+1];
                    int cnt_l=l[1][x][y-mid]-l[1][x][y+1];
                    if(cnt_k+cnt-cnt_l>=0){
                        left=mid;
                    }else{
                        right=mid;
                    }
                }

                cnt+=k[1][x][y-left]-k[1][x][y+1];
                x+=left;
                cout<<left<<endl;
            }
        }
    }else{
        for(int i=0;i<q;i++){
            ans=0;
            f(s[i]);
            cout<<ans-1<<endl;
        }

    }
}