#include <iostream>
#include <vector>
using namespace std;
int main()
{
	int t;
	cin >> t;
	vector<int> answ(t);
	for (int cnt = 0; cnt < t; cnt++)
	{
		int m, n;
		cin >> m >> n;
		vector<pair<int, int>> kings(n);
		for (int i = 0; i < n; i++)
		{
			int x, y;
			cin >> x >> y;
			kings[i] = { x - 1, y - 1 };
		}
		vector<vector<int>> board(m, vector<int>(m, 0));
		for (const auto& i : kings)
		{
			const int& sX = i.first;
			const int& sY = i.second;
			board[sX][sY] = -1e9;
			if (sX < m - 1)
				board[sX + 1][sY] = -1e9;
			if (sX < m - 1 && sY < m - 1)
				board[sX + 1][sY + 1] = -1e9;
			if (sY < m - 1)
				board[sX][sY + 1] = -1e9;
			if (sX > 0 && sY < m - 1)
				board[sX - 1][sY + 1] = -1e9;
			if (sX > 0)
				board[sX - 1][sY] = -1e9;
			if (sX > 0 && sY > 0)
				board[sX - 1][sY - 1] = -1e9;
			if (sY > 0)
				board[sX][sY - 1] = -1e9;
			if (sX < m - 1 && sY > 0)
				board[sX + 1][sY - 1] = -1e9;
			for (int x = sX + 2; x < m; x++)
				board[x][sY]++;
			for (int x = sX - 2; x >= 0; x--)
				board[x][sY]++;
			for (int y = sY + 2; y < m; y++)
				board[sX][y]++;
			for (int y = sY - 2; y >= 0; y--)
				board[sX][y]++;
			for (int d = 2; sX + d < m && sY + d < m; d++)
				board[sX + d][sY + d]++;
			for (int d = 2; sX - d >= 0 && sY - d >= 0; d++)
				board[sX - d][sY - d]++;
			for (int d = 2; sX + d < m && sY - d >= 0; d++)
				board[sX + d][sY - d]++;
			for (int d = 2; sX - d >= 0 && sY + d < m; d++)
				board[sX - d][sY + d]++;
		}
		int r = 0;
		for (int i = 0; i < m; i++)
			for (int j = 0; j < m; j++)
				if (board[i][j] == n)
					r++;
		answ[cnt] = r;
	}
	for (auto i : answ)
		cout << i << endl;
}