#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <queue>
#include <assert.h>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
const ll INF = (ll)1e18;
const double PI = acos(-1.0);

const int MAX_N = 50005;
int n;
int p[MAX_N];
int a[MAX_N], b[MAX_N];
ll ans[MAX_N];
vector<pair<int, int>> v[MAX_N];

int main()
{
    //freopen(".in", "r", stdin);
    //freopen(".out", "w", stdout);
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    cin >> n;
    for (int i = 1; i <= n; i++)
    {
        cin >> p[i] >> a[i] >> b[i];
    }

    for (int i = n; i >= 1; i--)
    {
        v[i].push_back({ a[i], b[i] });
        sort(v[i].begin(), v[i].end());
        vector<pair<int, int>> nw;
        for (int j = 0; j < v[i].size(); j++)
        {
            if (nw.empty() || v[i][j].second < nw.back().second)
            {
                nw.push_back(v[i][j]);
            }
            else
            {
                nw.pop_back();
                j--;
            }
        }

        ans[i] += (ll)(nw[0].first) * (ll)(nw[0].second);
        for (int j = 1; j < nw.size(); j++)
        {
            ans[i] += (ll)(nw[j].first - nw[j - 1].first) * (ll)(nw[j].second);
        }

        //v[p[i]] += nw;
        for (int j = 0; j < nw.size(); j++)
        {
            v[p[i]].push_back(nw[j]);
        }
    }

    for (int i = 1; i <= n; i++)
    {
        cout << ans[i] << endl;
    }

    return 0;
}