#pragma gcc optimize("Ofast,unroll-loops")
#pragma gcc target("sse,sse2,sse3,ssse3,sse4,fma,mmx,avx,tune=native")
#include <iostream>
#include <iomanip>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
using namespace std;
typedef long long ll;
typedef long double ld;
#define sz(x) int(x.size())
#define dbg(x) cout << #x << " = " << x << '\n'
#define dbg1(x) cout << #x << " = [ "; for (auto& el : x) cout << el << ' '; cout << "]\n"
void solve() {
	int m, n;
	cin >> m >> n;
	vector<vector<int>> g(m, vector<int>(m));
	for (int i = 0; i < n; ++i) {
		int x, y;
		cin >> x >> y;
		--x, --y;
		--g[y][x];
		if (y + 1 < m) --g[y + 1][x];
		if (y > 0) --g[y - 1][x];
		if (x + 1 < m) --g[y][x + 1];
		if (x > 0) --g[y][x - 1];
		if (y + 1 < m && x + 1 < m) --g[y + 1][x + 1];
		if (y > 0 && x > 0) --g[y - 1][x - 1];
		if (y + 1 < m && x > 0) --g[y + 1][x - 1];
		if (y > 0 && x + 1 < m) --g[y - 1][x + 1];
		for (int i = x + 2; i < m; ++i) ++g[y][i];
		for (int i = x - 2; i >= 0; --i) ++g[y][i];
		for (int i = y + 2; i < m; ++i) ++g[i][x];
		for (int i = y - 2; i >= 0; --i) ++g[i][x];
		for (int i = y - 2, j = x - 2; i >= 0 && j >= 0; --i, --j) ++g[i][j];
		for (int i = y + 2, j = x + 2; i < m && j < m; ++i, ++j) ++g[i][j];
		for (int i = y - 2, j = x + 2; i >= 0 && j < m; --i, ++j) ++g[i][j];
		for (int i = y + 2, j = x - 2; i < m && j >= 0; ++i, --j) ++g[i][j];
	}
	int cnt = 0;
	for (int i = 0; i < m; ++i) {
		for (int j = 0; j < m; ++j) {
			cnt += g[i][j] == n;
		}
	}
	cout << cnt << '\n';
}
signed main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout << fixed << setprecision(15);
	int t = 1;
	cin >> t;
	while (t--) solve();
}