n = int(input())

slaves = [[] for _ in range(n + 1)]
pr = [(0, 0)] * (n + 1)


info = [tuple(map(int, input().split())) for i in range(n)][::-1]

i = n

for p, ai, bi in info:
    slaves[p].append(i)
    pr[i] = (ai, bi)
    i -= 1


def cansolve(i, a, b) -> bool:
    if pr[i][0] >= a and pr[i][1] >= b:
        return True
    else:
        for slave in slaves[i]:
            if cansolve(slave, a, b):
                return True
        else:
            return False


results = [0] * n

for i in range(1, n + 1):
    for a in range(1, 11):
        for b in range(1, 11):
            results[i - 1] += cansolve(i, a, b)

print(*results, sep="\n")