#include <iostream>
#include <vector>

using namespace std;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int q;
    cin >> q;
    while (q--) {
        long long n;
        cin >> n;
        long long left = 0, right = 2e9;
        while (right - left > 1) {
            long long mid = (left + right) / 2ll;
            long long val = (mid / 2ll) * (mid / 2ll + 1ll) - 1ll + (mid / 2ll + 1ll) * (mid % 2ll + 1ll);
            if (val >= n) {
                right = mid;
            }
            else {
                left = mid;
            }
        }
        cout << right << "\n";
    }

    return 0;
}
