#include<iostream>
#include<vector>
#include<algorithm>
#include<cmath>
#include<set>
#include<map>
#include<string>
using namespace std;

#define ll long long
#define all(a) a.begin(),a.end()

template<typename T>
istream& operator >>(istream& cin, vector<T>& v) {
	for (auto& i : v)
		cin >> i;
	return cin;
}

template<typename T>
ostream& operator <<(istream& cout, vector<T>& v) {
	for (auto& i : v)
		cout << i << ' ';
	return cout;
}
int main() {
	int h, w, d;
	cin >> h >> w >> d;
	vector<vector<char>> gr(h, vector<char>(w));
	int ci, cj;
	for (int i = 0; i < h; i++) {
		for (int j = 0; j < w; j++) {
			cin >> gr[i][j];
			if (gr[i][j] == 'S') {
				ci = i; cj = j;
			}
		}
	}

	int ans = 0;
	int l;
	cin >> l;
	string cmd;
	cin >> cmd;

	int key = 0;

	for (auto& c : cmd) {
		int cnt = 0;
		if (c == 'R') {
			while (cj < w) {
				if (gr[ci][cj] == 'K') {
					key++;
					gr[ci][cj] = '.';
				}
				if (gr[ci][cj] == 'L') {
					if (key) {
						key--;
						gr[ci][cj] = '.';
					}
					else {
						cj--;
						break;
					}
				}
				if (gr[ci][cj] == '#') {
					cj--;
					break;
				}
				cj++;
				cnt++;
			}
			if (cj == w)
				cj--;
		}
		else if (c == 'L') {
			while (cj >= 0) {
				if (gr[ci][cj] == 'K') {
					key++;
					gr[ci][cj] = '.';
				}
				if (gr[ci][cj] == 'L') {
					if (key) {
						key--;
						gr[ci][cj] = '.';
					}
					else {
						cj++;
						break;
					}
				}
				if (gr[ci][cj] == '#') {
					cj++;
					break;
				}
				cj--;
				cnt++;
			}
			if (cj == -1)
				cj++;
		}
		else if (c == 'U') {
			while (ci >= 0) {
				if (gr[ci][cj] == 'K') {
					key++;
					gr[ci][cj] = '.';
				}
				if (gr[ci][cj] == 'L') {
					if (key) {
						key--;
						gr[ci][cj] = '.';
					}
					else {
						ci++;
						break;
					}
				}
				if (gr[ci][cj] == '#') {
					ci++;
					break;
				}
				ci--;
				cnt++;
			}
			if (ci == -1)
				ci++;
		}
		else if (c == 'D') {
			while (ci < h) {
				if (gr[ci][cj] == 'K') {
					key++;
					gr[ci][cj] = '.';
				}
				if (gr[ci][cj] == 'L') {
					if (key) {
						key--;
						gr[ci][cj] = '.';
					}
					else {
						ci--;
						break;
					}
				}
				if (gr[ci][cj] == '#') {
					ci--;
					break;
				}
					
				ci++;
				cnt++;
			}
			if (ci == h)
				ci--;
		}

		cout << cnt-1 << '\n';
	}
	//system("pause");
}