//#define _GLIBCXX_DEBUG
#include <iostream>
#include <vector>
#include <algorithm>
#include <numeric>
#include <set>
#include <queue>
#include <stack>
#include <deque>
#include <map>
#include <iomanip>
#include <string>
#include <unordered_map>
#include <cstring>
#include <unordered_set>
#include <ctime>
#include <climits>
#include <cmath>

using namespace std;

//#define int long long
typedef long long ll;

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    int n, m, d;
    cin >> n >> m >> d;
    if (d == 0)
    {
        vector<vector<char>> arr(n, vector<char>(m));
        int temp_i, temp_j;
        for (int i = 0; i < n; i++)
        {
            for (int j = 0; j < m; j++)
            {
                cin >> arr[i][j];
                if (arr[i][j] == 'S')
                {
                    temp_i = i;
                    temp_j = j;
                }
            }
        }
        vector<vector<int>> up(n, vector<int>(m)), down(n, vector<int>(m));
        vector<vector<int>> left(n, vector<int>(m)), right(n, vector<int>(m));
        for (int i = 0; i < n; i++)
        {
            for (int j = 0; j < m; j++)
            {
                if (arr[i][j] == '#')
                    left[i][j] = -1;
                else if (j == 0)
                    left[i][j] = 0;
                else
                    left[i][j] = left[i][j - 1] + 1;
            }
            for (int j = m - 1; j >= 0; j--)
            {
                if (arr[i][j] == '#')
                {
                    right[i][j] = -1;
                }
                else if (j == m - 1)
                {
                    right[i][j] = 0;
                }
                else
                {
                    right[i][j] = right[i][j + 1] + 1;
                }
            }
        }
        for (int j = 0; j < m; j++)
        {
            for (int i = 0; i < n; i++)
            {
                if (arr[i][j] == '#')
                    up[i][j] = -1;
                else if (i == 0)
                    up[i][j] = 0;
                else
                    up[i][j] = up[i - 1][j] + 1;
            }
            for (int i = n - 1; i >= 0; i--)
            {
                if (arr[i][j] == '#')
                    down[i][j] = -1;
                else if (i == n - 1)
                    down[i][j] = 0;
                else
                    down[i][j] = down[i + 1][j] + 1;
            }
        }
        int l;
        cin >> l;
        string s;
        cin >> s;
        for(auto c: s) {
            if (c == 'U') {
                cout << up[temp_i][temp_j] << '\n';
                temp_i -= up[temp_i][temp_j];
            }
            else if (c == 'D') {
                cout << down[temp_i][temp_j] << '\n';
                temp_i += down[temp_i][temp_j];
            }
            else if (c == 'R') {
                cout << right[temp_i][temp_j] << '\n';
                temp_j += right[temp_i][temp_j];
            }
            else if (c == 'L') {
                cout << left[temp_i][temp_j] << '\n';
                temp_j -= left[temp_i][temp_j];
            }
        }
    }
}