#include <iostream>
#include <set>
#include <algorithm>
#include <vector>
#include <random>
#include <ctime>
#include <map>
#include <unordered_map>

using namespace std;
#define null nullptr
#pragma GCC optimize("O3")

struct node {
    set<node*> go;
    string val;
    int f = 0;

    node(string s) : val(s) {}
};

map<string, node*> mp;
int crf = 2;

node* getpar(node* cr) {
    if (cr->f == crf) {
        cout << "INFINITE LOOP\n";
        return null;
    }
    cr->f = crf;
    if (cr->go.size() > 1) {
        cout << "TOO COMPLEX\n";
        return null;
    }
    if (cr->go.size() == 0 || *(cr->go.begin()) == cr) return cr;
    return getpar(*(cr->go.begin()));
}

void add_el(string s) {
    if (mp.find(s) == mp.end()) {
        mp[s] = new node(s);
    }
}



signed main() {
    int n;
    cin >> n;
    for (int i = 0; i < n; i++) {
        string s1, s2, ss;
        cin >> s1 >> ss >> s2;
        add_el(s1);
        add_el(s2);
        mp[s1]->go.insert(mp[s2]);
    }
    cin >> n;
    while (n--) {
        crf++;
        char c;
        cin >> c;
        if (c == '+') {
            string s1, s2, ss;
            cin >> s1 >> ss >> s2;
            add_el(s1);
            add_el(s2);
            mp[s1]->go.insert(mp[s2]);
        } else {
            string s;
            cin >> s;
            add_el(s);
            auto res = getpar(mp[s]);
            if (res != null) {
                cout << res->val << '\n';
            }
        }
    }
    return 0;
}
