#include <iostream>
#include <set>
#include <algorithm>
#include <vector>
#include <random>
#include <ctime>
#include <map>
#include <unordered_map>

using namespace std;
#define null nullptr
//#pragma GCC optimize("O3")

const inline bool hit(const int& x, const int& y, const int& xt, const int& yt) {
    return (!(x == xt && y == yt)) && (x == xt || y == yt || abs(x - xt) == abs(y - yt));
}

signed main() {
    int t;
    cin >> t;
    while (t--) {
        int m, n;
        cin >> m >> n;
        vector<pair<int, int>> kings;
        kings.reserve(n);
        n--;
        int x, y;
        cin >> x >> y;
        kings.push_back({x, y});
        vector<pair<int, int>> var;
        var.reserve(m * 5);
        for (int i = 1; i <= m; i++) {
            for (int j = 1; j <= m; j++) {
                if (hit(x,y,i,j)) {
                    var.push_back({i, j});
                }
            }
        }
        for (int i = 0; i < n; i++) {
            vector<pair<int, int>> nvars;
            nvars.reserve(var.size());
            cin >> x >> y;
            kings.push_back({x, y});
            for (auto par : var) {
                if (hit(par.first, par.second, x, y)) {
                    nvars.push_back(par);
                }
            }
            var = nvars;
        }
        int otv = 0;
        for (auto par : var) {
            bool f = true;
            for (int i = 0; i < kings.size(); i++) {
                for (int i1 = -1; i1 <= 1; i1++) {
                    for (int i2 = -1; i2 <= 1; i2++) {
                        if (par.first + i1 == kings[i].first && par.second + i2 == kings[i].second) {
                            f = false;
                        }
                    }
                }
            }
            if (f) otv++;
        }
        cout << otv << '\n';
    }
    return 0;
}
