#include <iostream>
#include <set>
#include <algorithm>
#include <vector>
#include <random>
#include <ctime>
#include <map>
#include <unordered_map>

using namespace std;
#define null nullptr
#define int long long
#pragma GCC optimize("O3")


int n;
vector<map<int, int>> mas;
vector<vector<int>> go;
int mxa = -1;

int calc(int cr) {
    int crmx = 0;
    int res = 0;
    int crmxa = (--mas[cr].end())->first;
    for (int i = crmxa; i >= 1; i--) {
        if (mas[cr].find(i) != mas[cr].end()) {
            crmx = max(crmx, mas[cr][i]);
        }
        res += crmx;
    }
    return res;
}

void dfs(int cr) {
    for (int to : go[cr]) {
        dfs(to);
        for (auto par : mas[to]) {
            mas[cr][par.first] = max(mas[cr][par.first], par.second);
        }
    }
}

signed main() {
    cin >> n;
    mas.resize(n);
    go.resize(n);
    for (int i = 0; i < n; i++) {
        int p, a, b;
        cin >> p >> a >> b;
        mxa = max(mxa, a);
        mas[i][a] = max(mas[i][a], b);
        if (p) {
            go[p - 1].push_back(i);
        }
    }
    dfs(0);
    for (int i = 0; i < n; i++) {
        cout << calc(i) << '\n';
    }
    return 0;
}
