#include <iostream>
#include <string>
#include <vector>

using namespace std;

int main()
{
	int h, w, d, l, ci = 0, cj = 0;
	cin >> h >> w >> d;
	vector<string> v(h);
	for (int i = 0; i < h; ++i)
	{
		cin >> v[i];
		for (int j = 0; j < w; ++j)
			if (v[i][j] == 'S')
			{
				v[i][j] = '.';
				ci = i;
				cj = j;
			}
	}
	cin >> l;
	string s;
	cin >> s;
	int keys = 0;
	for (int i = 0; i < l; ++i)
	{
		int r = 0;
		pair<int, int> p;
		if (s[i] == 'R') p = { 0, 1 };
		else if (s[i] == 'L') p = { 0, -1 };
		else if (s[i] == 'U') p = { -1, 0 };
		else p = { 1, 0 };
		while (true)
		{
			int ni = ci + p.first, nj = cj + p.second;
			if (ni < 0 || ni >= h || nj < 0 || nj >= w || v[ni][nj] == '#') break;
			if (v[ni][nj] == 'K')
			{
				++keys;
				v[ni][nj] = '.';
			}
			else if (v[ni][nj] == 'L')
			{
				if (keys > 0)
				{
					--keys;
					v[ni][nj] = '.';
				}
				else break;
			}
			++r;
			ci = ni;
			cj = nj;
		}
		cout << r << '\n';
	}
}