#include <iostream>
#include <vector>
#include <queue>
#include <map>

using namespace std;
typedef long long ll;

void solve() {
    ll n;
    cin >> n;
    if (n == 1) {
        cout << "1\n";
    } else {
        n--;
        ll l = 0, r = 1e9 + 9;
        while (r - l > 1) {
            ll mid = (l + r) >> 1;
            ll has = (2 + mid) * (mid - 1);
            if (has < n) {
                l = mid;
            } else {
                r = mid;
            }
        }
        if ((r + 2) * (r + -1) - r >= n) { cout << r * 2 - 2 << "\n"; }
        else {
            cout << r * 2 - 1<< "\n";
        }
    }
}

int main() {
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ll t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
}