#include <bits/stdc++.h>

using namespace std;

#define int long long
#define ALL(x) x.begin(), x.end()
#define RALL(x) x.rbegin(), x.rend()
#define makeVI(a, n) VI a (n); for (int i = 0; i < n; ++i) cin >> a[i];
#define makeVVI(a, n, m) VVI a (n, VI (m)); for (int i = 0; i < n; ++i) for (int j = 0; j < m; ++j) cin >> a[i][j];

#define M7 1000000007
#define M9 1000000009
#define INF 2000000000000000001
#define PI 3.14159265358979324

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int, int> PII;
typedef vector<int> VI;
typedef vector<PII> VPII;
typedef vector<VI> VVI;
typedef vector<VPII> VVPII;



void solve()
{
    int Q;
    //cin >> Q;
    Q = 1;
    while (Q--) {
        int h, w, d;
        cin >> h >> w >> d;

        PII s;
        vector<vector<char>> a (h, vector<char> (w));
        for (int i = 0; i < h; ++i) {
            for (int j = 0; j < w; ++j) {
                cin >> a[i][j];
                if (a[i][j] == 'S') {
                    s = {i, j};
                    a[i][j] = '.';
                }
            }
        }

        map<char, int> dict;
        dict['U'] = 0;
        dict['R'] = 1;
        dict['D'] = 2;
        dict['L'] = 3;

        if (d == 0) {
            vector<VVPII> link(h, VVPII(w, VPII(4)));
            for (int i = 0; i < h; ++i) {
                for (int j = 0; j < w; ++j) {
                    if (i == 0 || a[i-1][j] == '#') {
                        link[i][j][0] = {i, j};
                    } else {
                        link[i][j][0] = {link[i - 1][j][0]};
                    }
                }
            }
            for (int i = h - 1; i >= 0; --i) {
                for (int j = 0; j < w; ++j) {
                    if (i == h - 1 || a[i+1][j] == '#') {
                        link[i][j][2] = {i, j};
                    } else {
                        link[i][j][2] = link[i + 1][j][2];
                    }
                }
            }
            for (int j = 0; j < w; ++j) {
                for (int i = 0; i < h; ++i) {
                    if (j == 0 || a[i][j-1] == '#') {
                        link[i][j][3] = {i, j};
                    } else {
                        link[i][j][3] = {link[i][j - 1][3]};
                    }
                }
            }
            for (int j = w - 1; j >= 0; --j) {
                for (int i = 0; i < h; ++i) {
                    if (j == w - 1 || a[i][j+1] == '#') {
                        link[i][j][1] = {i, j};
                    } else {
                        link[i][j][1] = {link[i][j + 1][1]};
                    }
                }
            }

            int q;
            cin >> q;
            PII cur = s;
            for (int i = 0; i < q; ++i) {
                char c;
                cin >> c;

                PII ncur = link[cur.first][cur.second][dict[c]];
                cout << max(abs(cur.first - ncur.first), abs(cur.second - ncur.second)) << endl;
                cur = ncur;
            }
        } else {
            map<char, PII> dict1;
            dict1['U'] = {-1, 0};
            dict1['D'] = {1, 0};
            dict1['L'] = {0, -1};
            dict1['R'] = {0, 1};

            int q;
            cin >> q;
            PII cur = s;
            int cnt = 0;
            for (int i = 0; i < q; ++i) {
                char c;
                cin >> c;

                int ans = 0;
                while (true) {
                    if (cur.first + dict1[c].first < 0 || cur.first + dict1[c].first >= h || cur.second + dict1[c].second < 0 || cur.second + dict1[c].second >= w || a[cur.first + dict1[c].first][cur.second + dict1[c].second] == '#' || (a[cur.first  + dict1[c].first][cur.second + dict1[c].second] == 'L' && cnt == 0)) {
                        break;
                    } else {
                        cur = {cur.first + dict1[c].first, cur.second + dict1[c].second};
                        if (a[cur.first][cur.second] == 'K') {
                            ++cnt;
                            a[cur.first][cur.second] = '.';
                        } else if (a[cur.first][cur.second] == 'L') {
                            --cnt;
                            a[cur.first][cur.second] = '.';
                        }
                        ++ans;
                    }
                }

                cout << ans << endl;
            }
        }
    }
}

signed main(signed argc, char **argv)
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    if (argc > 1 && (string) argv[1] == "local") {
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    }
    solve();
}
