#include <bits/stdc++.h>

using namespace std;

#define int long long
#define ALL(x) x.begin(), x.end()
#define RALL(x) x.rbegin(), x.rend()
#define makeVI(a, n) VI a (n); for (int i = 0; i < n; ++i) cin >> a[i];
#define makeVVI(a, n, m) VVI a (n, VI (m)); for (int i = 0; i < n; ++i) for (int j = 0; j < m; ++j) cin >> a[i][j];

#define M7 1000000007
#define M9 1000000009
#define INF 2000000000000000001
#define PI 3.14159265358979324

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int, int> PII;
typedef vector<int> VI;
typedef vector<PII> VPII;
typedef vector<VI> VVI;
typedef vector<VPII> VVPII;

int cnt = 1;
unordered_map<string, int> h;
vector<set<int>> graf;
vector<char> used;
set<int> ans;
bool loop = false;
bool too = false;
void dfs (int v)
{
    if (graf[v].size() > 1) {
        too = true;
    }
    used[v] = 1;
    for (auto u: graf[v]) {
        if (u == v) {
            ans.insert(v);
        } else if (used[u] == 1) {
            loop = true;
        } else if (used[u] == 0) {
            dfs(u);
        }
    }
    used[v] = 2;
    if (graf[v].size() == 0) {
        ans.insert(v);
    }
}

int dfs1 (int v)
{
    int x = v;
    for (auto u: graf[v]) {
    	if (u != v) {
       	 	int x = dfs1(u);
        	graf[v].erase(u);
    	}
    }
    if (x != v) {
        graf[v].insert(x);
    }
    return x;
}

void solve()
{
    int Q;
    //cin >> Q;
    Q = 1;
    while (Q--) {
        int n;
        cin >> n;
        graf.push_back(set<int> ());
        for (int i = 0; i < n; ++i) {
            string s, abc, t;
            cin >> s >> abc >> t;

            if (h[s] == 0) {
                h[s] = cnt;
                ++cnt;
                graf.push_back(set<int> ());
            }
            if (h[t] == 0) {
                h[t] = cnt;
                ++cnt;
                graf.push_back(set<int> ());
            }

            graf[h[s]].insert(h[t]);
        }

        int q;
        cin >> q;
        if (n <= 1000 && q <= 1000) {
            for (int i = 0; i < q; ++i) {
                char c;
                cin >> c;

                if (c == '+') {
                    string s, abc, t;
                    cin >> s >> abc >> t;

                    if (h[s] == 0) {
                        h[s] = cnt;
                        ++cnt;
                        graf.push_back(set<int>());
                    }
                    if (h[t] == 0) {
                        h[t] = cnt;
                        ++cnt;
                        graf.push_back(set<int>());
                    }

                    graf[h[s]].insert(h[t]);
                } else {
                    string s;
                    cin >> s;

                    if (h[s] == 0) {
                        h[s] = cnt;
                        ++cnt;
                        graf.push_back(set<int>());
                    }

                    used.assign(cnt, 0);
                    ans.clear();
                    loop = false;
                    too = false;
                    dfs(h[s]);

                    if (ans.size() >= 2 || too) {
                        cout << "TOO COMPLEX" << endl;
                    } else if (loop) {
                        cout << "INFINITE LOOP" << endl;
                    } else {
                        int x = *ans.begin();
                        for (auto p: h) {
                            if (p.second == x) {
                                cout << p.first << endl;
                                break;
                            }
                        }
                    }
                }
            }
        } else {
            VI r_h (cnt+1);
            for (auto p: h) {
                int x = 0;
                for (int i = p.first.size()-1, mult = 1; i >= 0; --i, mult *= 27) {
                    x += (p.first[i] - 'A' + 1) * mult;
                }
                r_h[p.second] = x;
            }
            for (int i = 0; i < q; ++i) {
                char c;
                cin >> c;

                if (c == '+') {
                    string s, abc, t;
                    cin >> s >> abc >> t;

                    if (h[s] == 0) {
                        h[s] = cnt;
                        int x = 0;
                        for (int i = s.size()-1, mult = 1; i >= 0; --i, mult *= 27) {
                            x += (s[i] - 'A' + 1) * mult;
                        }
                        r_h.push_back(x);
                        ++cnt;
                        graf.push_back(set<int>());
                    }
                    if (h[t] == 0) {
                        h[t] = cnt;
                        int x = 0;
                        for (int i = t.size()-1, mult = 1; i >= 0; --i, mult *= 27) {
                            x += (t[i] - 'A' + 1) * mult;
                        }
                        r_h.push_back(x);
                        ++cnt;
                        graf.push_back(set<int>());
                    }

                    graf[h[s]].insert(h[t]);
                } else {
                    string s;
                    cin >> s;

                    if (h[s] == 0) {
                        h[s] = cnt;
                        int x = 0;
                        for (int i = s.size()-1, mult = 1; i >= 0; --i, mult *= 27) {
                            x += (s[i] - 'A' + 1) * mult;
                        }
                        r_h.push_back(x);
                        ++cnt;
                        graf.push_back(set<int>());
                    }

                    int ans = r_h[dfs1(h[s])];
                    string res;
                    while (ans) {
                        res += (char)(ans % 27 + 'A');
                        ans /= 27;
                    }
                    reverse(ALL(res));
                    cout << res << " ";
                }
            }
        }
    }
}

signed main(signed argc, char **argv)
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    if (argc > 1 && (string) argv[1] == "local") {
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    }
    solve();
}
