#include <bits/stdc++.h>

using namespace std;

#define int long long
#define ALL(x) x.begin(), x.end()
#define RALL(x) x.rbegin(), x.rend()
#define makeVI(a, n) VI a (n); for (int i = 0; i < n; ++i) cin >> a[i];
#define makeVVI(a, n, m) VVI a (n, VI (m)); for (int i = 0; i < n; ++i) for (int j = 0; j < m; ++j) cin >> a[i][j];

#define M7 1000000007
#define M9 1000000009
#define INF 2000000000000000001
#define PI 3.14159265358979324

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int, int> PII;
typedef vector<int> VI;
typedef vector<PII> VPII;
typedef vector<VI> VVI;
typedef vector<VPII> VVPII;



void solve()
{
    int Q;
    cin >> Q;
    //Q = 1;
    while (Q--) {
        int m, n;
        cin >> m >> n;

        VVI a (m, VI(m, 0));
        for (int i = 0; i < n; ++i) {
            int x, y;
            cin >> x >> y;
            --x; --y;

            for (int i = 0; i < m; ++i) {
                if (i >= x-1 && i <= x+1) {
                    a[i][y] = -INF;
                } else {
                    ++a[i][y];
                }
            }
            for (int i = 0; i < m; ++i) {
                if (i >= y-1 && i <= y+1) {
                    a[x][i] = -INF;
                } else {
                    ++a[x][i];
                }
            }
            for (int i = 0; x+i < m && y+i < m; ++i) {
                if (i <= 1) {
                    a[x+i][y+i] = -INF;
                } else {
                    ++a[x+i][y+i];
                }
            }
            for (int i = 0; x-i >= 0 && y-i >= 0; ++i) {
                if (i <= 1) {
                    a[x-i][y-i] = -INF;
                } else {
                    ++a[x-i][y-i];
                }
            }
            for (int i = 0; x+i < m && y-i >= 0; ++i) {
                if (i <= 1) {
                    a[x+i][y-i] = -INF;
                } else {
                    ++a[x+i][y-i];
                }
            }
            for (int i = 0; x-i >= 0 && y+i < m; ++i) {
                if (i <= 1) {
                    a[x-i][y+i] = -INF;
                } else {
                    ++a[x-i][y+i];
                }
            }
        }

        int res = 0;
        for (int i = 0; i < m; ++i) {
            for (int j = 0; j < m; ++j) {
                if (a[i][j] == n) {
                    ++res;
                }
            }
        }
        cout << res << endl;
    }
}

signed main(signed argc, char **argv)
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    if (argc > 1 && (string) argv[1] == "local") {
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    }
    solve();
}
