// #include "pch.h"


#include <iostream>
#include <fstream>
#include <vector>
#include <string>
#include <stack>
#include <queue>
#include <deque>
#include <cmath>
#include <set>
#include <map>
#include <algorithm>


using namespace::std;
int INF = 1e9 + 100;



int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0), cout.tie(0);
	cout.setf(ios::fixed);
	cout.precision(10);


	int q;
	cin >> q;
	for (int qq = 0; qq < q; qq++) {

		int n, m;
		cin >> n >> m;
		vector<vector<int>>v(n + 2, vector<int>(n + 2));
		vector<vector<int>>d(n + 2, vector<int>(n + 2));


		for (int i = 0; i < m; i++) {
			int a, b;
			cin >> a >> b;
			// a = n - a + 1;
			// b = n - b + 1;

			v[a][b]++;

			d[a - 1][b - 1] = 1;
			d[a - 1][b - 0] = 1;
			d[a - 1][b + 1] = 1;
			d[a][b - 1] = 1;
			d[a][b - 0] = 1;
			d[a][b + 1] = 1;
			d[a + 1][b - 1] = 1;
			d[a + 1][b - 0] = 1;
			d[a + 1][b + 1] = 1;

		}

		int ans = 0;
		for (int i = 1; i <= n; i++) {
			for (int j = 1; j <= n; j++) {

				if (d[i][j] == 1) continue;

				int cnt = 0;

				for (int k = 0; k <= n; k++) {
					cnt += v[k][j];
				}

				for (int k = 0; k <= n; k++) {
					cnt += v[i][k];
				}

				for (int k = max(-i, -j); k <= n - max(i, j); k++) {
					cnt += v[i + k][j + k];
				}

				for (int k = -n; k <= n; k++) {
					if (0 <= i - k && i - k <= n && 0 <= j + k && j + k <= n)
						cnt += v[i - k][j + k];
				}


				// cout << i << " " << j << " => " << cnt << "\n";
				if (cnt == m)
					ans++;


			}
		}

		cout << ans << "\n";
	}


	return 0;
}
