// #include "pch.h"


#include <iostream>
#include <fstream>
#include <vector>
#include <string>
#include <stack>
#include <queue>
#include <deque>
#include <cmath>
#include <set>
#include <map>
#include <algorithm>


using namespace::std;
int INF = 1e9 + 100;



int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0), cout.tie(0);
	cout.setf(ios::fixed);
	cout.precision(10);


	long long n, a, b;
	cin >> n >> a >> b;

	// 
	// ABBBABBB
	//  ABBBABBB
	//   ABBBABBB

	// A < B
	// AABBBAABBB
	//   AABBBAABBB
	//          AABBBAABBB   


	// ABAB
	//  ABAB
	//     ABAB
	//      
	// 
	// AAABBBBBBAAABBBBBB
	//    AAABBBBBBAAABBBBBB
	//       AAABBBBBBAAABBBBBB
	//                   AAABBBBBBAAABBBBBB
	// 
	// 
	// AABBBAABBB
	//   AABBBAABBB
	//          AABBBAABBB
	//            AABBBAABBB
	//
	// A + B == B + a
	// BB...BB....BAA...AA
	// AA...AABB...BB...BB
	//

	/*
	
	AABBBBBAABBBBB
	  AABBBBBAABBBBB
	    AABBBBBAABBBBB
                 AABBBBBAABBBBB		  
				   AABBBBBAABBBBB 
	*/

	long long ans;




	if (a == b) {
		if (n % 2 == 0) ans = 4 * (n / 2) * a + b;
		else ans = 4 * (n / 2 + 1) * a;
	}
	else if (b < a) ans = n * (2 * a + b) + b;
	else {
		long long mid = b / a;
		long long add = b - mid * a;

		long long group_without_b = (a + b) + a * (mid + 1);
		long long groups = n / (mid + 1);
		long long extra_groups = n % (mid + 1);
		long long extra_add = extra_groups * a + b + a + b;

		ans = group_without_b * groups + extra_add;

	}

	cout << ans;
 


	return 0;
}
