#include <bits/stdc++.h>

using namespace std;

#define all(x) x.begin(), x.end()
#define endl '\n'
#define pb emplace_back
#define re return
#define fi first
#define se second
#define rep(i, n) for (int i = 0; i < n; i++)
#define rrep(i, n) for (int i = (n) - 1; i >= 0; i--)
#define sz(x) int(x.size())

typedef pair<int, int> ii;
typedef long long ll;
typedef vector<string> vs;
typedef vector<ii> vii;
typedef vector<int> vi;
typedef vector<bool> vb;
typedef vector<vi> vvi;

int code(string &s)
{
    int ret = 0;
    rrep(i, 4)
    {
        ret *= 27;
        if (i >= sz(s)) ret += 0;
        else ret += (s[i] - 'A') + 1;
    }
    re ret;
}

string decode(int x)
{
    string ret = "";
    while (x != 0)
    {
        ret += char('A' + (x % 27) - 1);
        x /= 27;
    }
    re ret;
}

int N = 27 * 27 * 27 * 27 + 5;
vi par(N);

void dsu_make(int x)
{
    par[x] = x;
}

int dsu_get(int x)
{
    if (par[x] == x) re x;
    re par[x] = dsu_get(par[x]);
}

void dsu_union(int x, int y)
{
    y = dsu_get(y);
    //cout << "got " << y << ' ' << dsu_get(y) << endl;
    par[x] = y;
}

void solve()
{
    rep(i, N)
    {
        dsu_make(i);
    }
    int n;
    cin >> n;
    vvi gr(N);
    rep(i, n)
    {
        string a, is, b;
        cin >> a >> is >> b;
        dsu_union(code(a), code(b));
        if (sz(gr[code(a)]) == 0 || gr[code(a)][0] != code(b)) gr[code(a)].pb(code(b));
    }
    int q;
    cin >> q;
    if (n <= 1000 && q <= 1000) {
        rep(i, q)
        {
            char type;
            cin >> type;
            if (type == '+') {
                string a, is, b;
                cin >> a >> is >> b;
                if (sz(gr[code(a)]) == 0 || gr[code(a)][0] != code(b)) gr[code(a)].pb(code(b));
            }
            else {
                set<int> was;
                string a;
                cin >> a;
                int cur = code(a);
                while (1)
                {
                    if (sz(gr[cur]) > 1) {
                        cout << "TOO COMPLEX\n";
                        break;
                    }
                    else if (was.count(cur) > 0) {
                        cout << "INFINITE LOOP\n";
                        break;
                    }
                    else if (sz(gr[cur]) == 0 || (sz(gr[cur]) == 1 && gr[cur][0] == cur)) {
                        cout << decode(cur) << endl;
                        break;
                    }
                    else {
                        was.insert(cur);
                        cur = gr[cur][0];
                    }
                }
            }
        }
        re;
    }
    rep(i, q)
    {
        char type;
        cin >> type;
        if (type == '+') {
            string a, is, b;
            cin >> a >> is >> b;
            dsu_union(code(a), code(b));
        }
        else {
            string a;
            cin >> a;
            cout << decode(dsu_get(code(a))) << endl;
        }
    }
}

int main()
{
    ios::sync_with_stdio(0); cout.tie(0);
    int t = 1;
    //cin >> t;
    while (t--) solve();
    return 0;
}
