#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2,tune=native")
//#include <intrin.h>

#include <bits/stdc++.h>
#include <chrono>
#include <random>
#include <ctime>

using namespace std;

typedef unsigned long long ull;
typedef long long ll;
typedef long double ld;
#define mp make_pair
#define pb push_back
#define rep(i, n) for (ll i = 0; i < (n); i++)
#define repb(i, n) for (ll i = n - 1; i>=0; --i)
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
const ll inf = 1e9;
const ll MAXN = 1e6;
const int sz = 11;
vector<vector<int>> g;
vector<int> mx_B;
vector<pair<int, int>> delta;

void dfs(int v) {
    for (int i = 1; i <= delta[v].first; ++i) {
        mx_B[i] = max(mx_B[i], delta[v].second);
    }
    for (int u : g[v])
        dfs(u);
}

inline void SOLVE() {
    int n;
    cin >> n;
    delta.resize(n);
    g.resize(n);
    for (int i = 0; i < n; ++i) {
        int p;
        cin >> p >> delta[i].first >> delta[i].second;
        if (p == 0) {
            continue;
        }
        p--;
        g[p].pb(i);
    }
    rep(i, n) {
        mx_B.assign(101, 0);
        dfs(i);
        int ans = 0;
        rep(j, mx_B.size()) {
            ans += mx_B[j];
        }
        cout << ans << '\n';
    }
}

inline void IQ() {
    ios::sync_with_stdio(false);
    cin.tie(NULL);
}

signed main() {
#ifdef GOSHA
    freopen("../IO/input.txt", "r", stdin);
    freopen("../IO/output.txt", "w", stdout);
#endif
    IQ();
    ll T = 1;
    // cin >> T;
    while (T--) {
        SOLVE();
    }
    return 0;
}