#include<iostream>
#include<string>
#include<cmath>
#include<vector>
#include<map>
#include<set>
using namespace std;

vector<set<int>> mass(200000);
vector<int> used(200000);
vector<string> name(1);
map<string, int> dict;
int cnt = 1;
void add(string f, string s)
{
	if (dict[f] == 0)
	{
		dict[f] = cnt;
		cnt++;
		name.push_back(f);
	}
	if (dict[s] == 0)
	{
		dict[s] = cnt;
		cnt++;
		name.push_back(s);
	}
	mass[dict[f]].insert(dict[s]);
}

int ask(int now)
{
	bool self = false;
	vector<int> q;
	set<int>::iterator iter;
	for (iter = mass[now].begin(); iter != mass[now].end(); iter++)
	{
		if (*iter == now)self = true;
		else q.push_back(*iter);
	}
	if (self || q.size()==0)
	{
		if (q.size() > 0) return -2;
		else return now;
	}
	else if (q.size() > 1) return -2;
	else
	{
		if (used[q[0]]) return -1;
		else
		{
			used[now] = true;
			int ans = ask(q[0]);
			used[now] = false;
			return ans;
		}
	}
}

int main()
{
	int n, q;
	string f, s, type, m;
	cin >> n;
	for (int i = 0; i < n; i++)
	{
		cin >> f >> m >> s;
		add(f, s);
	}
	cin >> q;
	for (int i = 0; i < q; i++)
	{
		cin >> type;
		if (type == "+")
		{
			cin >> f >> m >> s;
			add(f, s);
		}
		else
		{
			cin >> f;
			if (dict[f] == 0)
			{
				dict[f] = cnt;
				cnt++;
				name.push_back(f);
			}
			int now = ask(dict[f]);
			if (now == -1)cout << "INFINITE LOOP" <<'\n';
			else if(now==-2)cout << "TOO COMPLEX" << '\n';
			else cout << name[now] << '\n';
		}
	}
	return 0;
}