#include<iostream>
#include<string>
#include<cmath>
#include<vector>
#include<map>
#include<set>
using namespace std;

struct pearson
{
	int h, w, c;
	set<pair<int, int>> cnt;
};

int main()
{
	int n;
	cin >> n;
	vector<pearson> mass(n+1);
	for (int i = 1; i <= n; i++)
		cin >> mass[i].h >> mass[i].w >> mass[i].c;
	for (int i = n; i > 0; i--)
	{
		for (int a = 1; a <= mass[i].w; a++)
			for (int b = 1; b <= mass[i].c; b++)
				mass[i].cnt.insert(make_pair(a, b));
		set<pair<int, int>>::iterator iter;
		for(iter= mass[i].cnt.begin(); iter!= mass[i].cnt.end(); iter++)
			mass[mass[i].h].cnt.insert(*iter);
	}
	for (int i = 1; i <= n; i++)
		cout << mass[i].cnt.size() << endl;
	return 0;
}