﻿#include <iostream>
#include <fstream>
#include <vector>
#include <algorithm>
#include <chrono>
#include <random>
#include <set>
#include <map>
#include <string>
#include <queue>
using namespace std;
typedef long long ll;
#define all(v) v.begin(), v.end()
mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

vector<vector<ll>>gr;
vector<pair<ll, ll>>vec;
vector<ll>ans;

vector<pair<ll, ll>> dfs(ll v) {
    vector<pair<ll, ll>>al;
    for (auto u : gr[v]) {
        auto r = dfs(u);
        for (auto i : r) {
            al.push_back(i);
        }
    }
    al.push_back(vec[v]);
    sort(all(al));
    ll sum = 0;
    ll a = al.back().first, b = 0;
    for (ll i = al.size() - 1; i >= 0; i--) {
        sum += (a - al[i].first) * b;
        b = max(b, al[i].second);
        a = al[i].first;
    }
    sum += a * b;
    ans[v] = sum;
    return al;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll n; cin >> n;
    gr.resize(n);
    vec.resize(n);
    ans.resize(n);
    for (ll i = 0; i < n; i++) {
        ll p, a, n;
        cin >> p >> vec[i].first >> vec[i].second;
        if (p != 0) {
            gr[p - 1].push_back(i);
        }
    }
    dfs(0);
    for (int i = 0; i < n; i++) {
        cout << ans[i] << "\n";
    }
}