#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <queue>
#include <unordered_set>
#include <unordered_map>
#include <math.h>
#include <cmath>
#include <complex>
#include <algorithm>

using namespace std;

#define rep(i, n) for (ll i = 0; i < n; i++)
#define reep(i, a, n) for (ll i = a; i < n; i++)
#define per(i, n) for (ll i = n - 1; i >= 0; i--)

#define all(x) x.begin(), x.end()
#define pb(a) push_back(a)
#define mp(a, b) make_pair(a, b)
#define sz(x) (int)x.size()
#define len() length()

#define ff first
#define ss second

#define print2(a, b) cout << a << ' ' << b << endl
#define print3(a, b, c) cout << a << ' ' << b << ' ' << c << endl
#define print4(a, b, c, d) cout << a << ' ' << b << ' ' << c << '' << d << endl
#define printvec(a)       \
    for (auto _ : a)      \
        cout << _ << ' '; \
    cout << endl

typedef long long ll;
typedef long double ld;

typedef vector<int> vi;
typedef vector<ll> vll;
typedef vector<bool> vb;

typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

void solve();

signed main()
{
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(0);

    int n = 1;

    cin >> n;

    rep(i, n) solve();
}

vector <int> stkol;
vector <int> skol;
vector <int> dkol;
vector <int> dpkol;
vector <vb> pol;


void solve()
{
    ll n, m;
    cin >> m >> n;
    vi stkol(m), skol(m), dkol(2 * m + 1), dpkol(2 * m + 1);
    vector <vb> pol(m, vb(m));
    rep(i, n){
        int x, y;
        cin >> x >> y;
        x--; y--;
        pol[x][y] = 1;
        stkol[x]++;
        skol[y]++;
        dkol[x - y + m]++;
        dpkol[x + y]++;
    }
    /*
    printvec(stkol);
    printvec(skol);
    printvec(dpkol);
    printvec(dkol);
    */
    ll ans = 0;
    rep(i, m){
        rep(j, m){
            if (i + 1 < m){
                if (j + 1 < m){
                    if (pol[i + 1][j + 1]) continue;
                }
                if (j - 1 >= 0){
                    if (pol[i + 1][j - 1]) continue;
                }
                if (pol[i + 1][j]) continue;
            }
            if (i - 1 >= 0){
                if (j + 1 < m){
                    if (pol[i - 1][j + 1]) continue;
                }
                if (j - 1 >= 0){
                    if (pol[i - 1][j - 1]) continue;
                }
                if (pol[i - 1][j]) continue;
            }
            if (j + 1 < m){
                if (pol[i][j + 1]) continue;
            }
            if (j - 1 >= 0){
                if (pol[i][j - 1]) continue;
            }
            if (pol[i][j]) continue;
            /*
            print2(i, j);
            cout << dpkol[i + j] + dkol[i - j + m] + skol[j] + stkol[i] << endl;
            */
            if (dpkol[i + j] + dkol[i - j + m] + skol[j] + stkol[i] == n) ans++;
        }
    }
    cout << ans << endl;



}