#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <queue>
#include <unordered_set>
#include <unordered_map>
#include <math.h>
#include <cmath>
#include <complex>
#include <algorithm>

using namespace std;

#define rep(i, n) for (ll i = 0; i < n; i++)
#define reep(i, a, n) for (ll i = a; i < n; i++)
#define per(i, n) for (ll i = n - 1; i >= 0; i--)

#define all(x) x.begin(), x.end()
#define pb(a) push_back(a)
#define mp(a, b) make_pair(a, b)
#define sz(x) (int)x.size()
#define len() length()

#define ff first
#define ss second

#define print2(a, b) cout << a << ' ' << b << endl
#define print3(a, b, c) cout << a << ' ' << b << ' ' << c << endl
#define print4(a, b, c, d) cout << a << ' ' << b << ' ' << c << '' << d << endl
#define printvec(a)       \
    for (auto _ : a)      \
        cout << _ << ' '; \
    cout << endl

typedef long long ll;
typedef long double ld;

typedef vector<int> vi;
typedef vector<ll> vll;
typedef vector<bool> vb;

typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

void solve();

signed main()
{
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(0);

    int n = 1;

    //cin >> n;

    rep(i, n) solve();
}

vector <vi> g;
vector <int> a;
vi b;
vector<vector<int>> pr;
ll maxa;
vb used;

void dfs(int v){
    used[v] = 1;
    for (auto u : g[v]){
        dfs(u);
    }
    reep(i, 1, maxa + 1){
        if (a[v] >= i) {
            pr[v][i] = b[v];
        }
        //print3(v, i, pr[v][i]);
        for (auto u : g[v]){
            pr[v][i] = max(pr[v][i], pr[u][i]);
        }
    }
}

void solve()
{
    int n;
    cin >> n;
    g.resize(n);
    a.resize(n);
    b.resize(n);
    used.resize(n);
    pr.resize(n);
    rep(i, n){
        ll p;
        cin >> p >> a[i] >> b[i];
        p--;
        if (p != -1)
        g[p].pb(i);
    }
    maxa = *max_element(all(a));
    rep(i, n){
        pr[i].resize(maxa + 1);
    }
    rep(i, n){
        if (!used[i])
            dfs(i);
    }
    rep(i, n){
        ll ans = 0;
        reep(j, 1, maxa + 1){
            ans += pr[i][j];
        }
        cout << ans << endl;
    }
}