#include <bits/stdc++.h>

#define int long long
#define pb push_back
#define all(x) (x).begin(), x.end()
#pragma comment(linker, "/STACK:66777216")

typedef long double ld;

using namespace std;

template<class A, class B> ostream& operator <<(ostream& out, const pair<A, B>& p) {
    return out << "(" << p.first << ", " << p.second << ")";
}
template<class A> ostream& operator <<(ostream& out, const vector<A>& v) {
    out << "[";
    for (int i = 0; i < v.size(); i++) {
        if (i) out << ", ";
        out << v[i];
    }
    return out << "]";
}

const int N = 1e5, T = 1e5 + 1, INF = 1e18, MOD = 1e9 + 7;

map<string, int> it;
map<int, string> rev;
int cnt = 0;

vector<vector<int>> f;
vector<bool> used;

int col = 1;

int dfs(int v) {
    used[v] = 1;
    bool what = 0, loop = 0;
    int res = v;
    set<int> was;
    for (int to : f[v]) {
        if (was.find(to) != was.end()) continue;
        was.insert(to);
        if (!used[to]) {
            res = dfs(to);
        }
        else if(to != v){
            loop = 1;
        }
    }
    if (was.size() > 1) return -2;
    if (loop) return -1;
    return res;
}

signed main() {
    ifstream cin("input.txt");
    ofstream cout("output.txt");
    ios::sync_with_stdio(0);
    cin.tie(0);


    int n;
    cin >> n;
    string s, tmp, t;
    for (int i = 0; i < n; i++) {
        cin >> s >> tmp >> t;
        int a, b;
        if (it.find(s) == it.end()) {
            it[s] = cnt;
            rev[cnt] = s;
            a = cnt;
            f.pb({});
            cnt++;
        }
        else
            a = it[s];
        if (it.find(t) == it.end()) {
            it[t] = cnt;
            rev[cnt] = t;
            b = cnt;
            f.pb({});
            cnt++;
        }
        else
            b = it[t];
        f[a].pb(b);
    }
    n = cnt;
    used.resize(n);

    int qw;
    cin >> qw;
    char type;
    while (qw--) {
        cin >> type;
        if (type == '+') {
            cin >> s >> tmp >> t;
            int a, b;
            if (it.find(s) == it.end()) {
                it[s] = cnt;
                rev[cnt] = s;
                a = cnt;
                f.pb({});
                cnt++;
            }
            else
                a = it[s];
            if (it.find(t) == it.end()) {
                it[t] = cnt;
                rev[cnt] = t;
                b = cnt;
                f.pb({});
                cnt++;
            }
            else
                b = it[t];
            f[a].pb(b);
        }
        else {
            cin >> s;
            used.assign(n, 0);
            if (it.find(s) != it.end()) {
                int res = dfs(it[s]);
                if (res == -1)
                    cout << "INFINITE LOOP\n";
                else if (res == -2)
                    cout << "TOO COMPLEX\n";
                else
                    cout << rev[res] << '\n';
            }
            else
                cout << s << '\n';
        }
    }
}