#include<iostream>
#include<cmath>
#include<algorithm>
#include<vector>
#include<set>
#include<map>

using namespace std;

typedef long long ll;
 
map<string, set<string>> g;
set<string>used;
map<string, string> ans;
set<string> mn;
map<string, string>pr;

string get(string v) {
    if (pr[v] == v) {
        return v;
    }
    return pr[v] = get(pr[v]);
}

void un(string x, string y) {
    x = get(x);
    y = get(y);
    pr[y] = x;
    ans[x] = ans[y];
}

string dfs(string v) {
    used.insert(v);
    
    if (g[v].size() > 1) {
        return "TOO COMPLEX";
    }
    if (g[v].empty())
        return v;
    if (g[v].size() == 1 && *(g[v].begin()) == v) {
        return v;
    }
    if (used.find(*(g[v].begin())) != used.end() && *(g[v].begin()) != v) {
        return "INFINITE LOOP";
    }
    return dfs(*(g[v].begin()));
    
}

void solve() {
    int n;
    cin >> n;
    
    
    string x, y, op;

    vector<pair<string, string>> in(n);
    for (int i = 0; i < n; i++) {
        cin >> x >> op >> y;
        in[i].first = x;
        in[i].second = y;
    }
    int q;
    cin >> q;
    if (n <= 1e3 && q <= 1e3) {
        for (int i = 0; i < n; i++) {
            x = in[i].first;
            y = in[i].second;
            g[x].insert(y);
        }
        while (q--) {
            char t;
            cin >> t;
            if (t == '+') {
                cin >> x >> op >> y;
                g[x].insert(y);
            }
            else {
                cin >> x;
                used.clear();
                cout << dfs(x) << "\n";

            }
        }
    }
    else {
        
        for (int i = 0; i < n; i++) {
            x = in[i].first;
            y = in[i].second;
            if (mn.find(x) == mn.end()) {
                mn.insert(x);
                pr[x] = x;
                ans[x] = x;
            }
            if (mn.find(y) == mn.end()) {
                mn.insert(y);
                pr[y] = y;
                ans[y] = y;
            }
            un(x, y);
        }
        char t;
        while (q--) {
            cin >> t;
            if (t == '+') {
                cin >> x >> op >> y;
                if (mn.find(x) == mn.end()) {
                    mn.insert(x);
                    pr[x] = x;
                    ans[x] = x;
                }
                if (mn.find(y) == mn.end()) {
                    mn.insert(y);
                    pr[y] = y;
                    ans[y] = y;
                }
                un(x, y);
            }
            else {
                cin >> x;
                cout << ans[get(x)] << "\n";
            }
        }
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    /*int t;
    cin >> t;
    while (t--)*/
        solve();
    return 0;
}
