#include<iostream>
#include<cmath>
#include<algorithm>
#include<vector>
#include<set>
#include<map>

using namespace std;

typedef long long ll;

vector<vector<int>>g;
vector<pair<int, int>> p;
vector<int> ans;
vector<vector<int>>m;
int ma;

void dfs(int v) {
    ll sum = 0;
    for (int i = 0; i < p[v].first; i++) {
        m[v][i] = p[v].second;
        sum += p[v].second;
    }

    for (auto u : g[v]) {
        dfs(u);
        for (int i = 0; i < ma; i++) {
            if (m[u][i] > m[v][i]) {
                sum += m[u][i] - m[v][i];
                m[v][i] = m[u][i];
            }
        }
    }
    ans[v] = sum;
}

void solve() {
    int n;
    cin >> n;
    p.resize(n);
    g.resize(n);
    ans.resize(n);
    int r = 0;
    ma = 0;
    for (int i = 0; i < n; i++) {
        int pr;
        cin >> pr >> p[i].first >> p[i].second;
        ma = max(ma, p[i].first);
        pr--;
        if (pr == -1)
            r = i;
        else
            g[pr].push_back(i);
    }
    m.resize(n, vector<int>(ma, 0));
    dfs(r);
    for (auto u : ans) {
        cout << u << "\n";
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    
        solve();
    return 0;
}
