#include<iostream>
#include<cmath>
#include<algorithm>
#include<vector>
#include<set>
#include<map>

using namespace std;

typedef long long ll;
 
map<string, set<string>> g;
set<string>used;
map<string, string> ans;
set<string> mn;
map<string, string>pr;

string get(string v) {
    if (pr[v] == v) {
        return v;
    }
    return pr[v] = get(pr[v]);
}

void un(string x, string y) {
    x = get(x);
    y = get(y);
    pr[y] = x;
    ans[x] = ans[y];
}

string dfs(string v) {
    used.insert(v);
    
    if (g[v].size() > 1) {
        return "TOO COMPLEX";
    }
    if (g[v].empty())
        return v;
    if (g[v].size() == 1 && *(g[v].begin()) == v) {
        return v;
    }
    if (used.find(*(g[v].begin())) != used.end() && *(g[v].begin()) != v) {
        return "INFINITE LOOP";
    }
    return dfs(*(g[v].begin()));
    
}

void solve() {
    int n;
    cin >> n;
    set<pair<int, int>> a;
    int x;
    for (int i = 0; i < n; i++) {
        cin >> x;
        a.insert({ i + 1, x});
    }
    int q;
    cin >> q;
    
    for (int i = 0; i < q; i++) {
        cin >> x;
        bool f = 0;
        for (auto u : a) {
            if (x % (u.second + 1) != 1) {
                cout << u.first << "\n";
                f = 1;
                break;
            }
        }
        if (!f)
            cout << -1 << "\n";
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    /*int t;
    cin >> t;
    while (t--)*/
        solve();
    return 0;
}
