#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define fastio ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0)
#define sz(v) (int)(v).size()

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> indexed_set;

const ll INF = ll(2e9) + 100100, LINF = ll(1e18) + 100100;
const double EPS = 1e-9, PI = atan2(0.0, -1.0);
const int MODS[] = {signed(1e9) + 7, signed(1e9) + 9, 998244353};
const int PS[] = {117, 239, signed(1e5) + 3, 177013};
const int MAXN = signed(1e5) + 100, MAXLOG = 20;

mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count());

map<string, set<string>> g;
map<string, bool> used;
bool LOOP = false, COMPLEX = false, stop = false;
string last;

void dfs(const string &v) {
    used[v] = true, last = v;

    if (sz(g[v]) == 2) {
        COMPLEX = true;
        stop = true;
        return;
    }

    for (auto to : g[v]) {
        if (used[to]) {
            if (to != v) {
                LOOP = true;
                stop = true;
                return;
            }
        }
        else dfs(to);

        if (stop) return;
    }
}

signed main() {
    fastio;
#ifdef hikki
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int n; cin >> n;

    for (int i = 0; i < n; ++i) {
        string s, trash, t;
        cin >> s >> trash >> t;
        g[s].insert(t);
    }

    int q; cin >> q;

    while (q--) {
        char type; cin >> type;

        if (type == '+') {
            string s, trash, t;
            cin >> s >> trash >> t;
            g[s].insert(t);
        }
        else {
            string s; cin >> s;
            used.clear(), last.clear();
            LOOP = COMPLEX = stop = false;

            dfs(s);

            if (COMPLEX) cout << "TOO COMPLEX\n";
            else if (LOOP) cout << "INFINITE LOOP\n";
            else cout << last << "\n";
        }
    }

    return 0;
}