#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define fastio ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0)
#define sz(v) (int)(v).size()

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> indexed_set;

const ll INF = ll(2e9) + 100100, LINF = ll(1e18) + 100100;
const double EPS = 1e-9, PI = atan2(0.0, -1.0);
const int MODS[] = {signed(1e9) + 7, signed(1e9) + 9, 998244353};
const int PS[] = {117, 239, signed(1e5) + 3, 177013};
const int MAXN = signed(1e5) + 100, MAXLOG = 20;

mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count());

vector<vector<int>> g;
vector<int> ans, a, b;

set<pair<int, int>> dfs(int v, int p = -1) {
    set<pair<int, int>> uniq;

    for (auto to : g[v]) {
        if (to == p) continue;
        set<pair<int, int>> temp = dfs(to, v);
        for (auto i : temp) uniq.insert(i);
    }

    for (int i = 1; i <= a[v]; ++i)
        for (int j = 1; j <= b[v]; ++j)
            uniq.insert({i, j});

    ans[v] = sz(uniq);
    
    return uniq;
}

signed main() {
    fastio;
#ifdef hikki
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int n; cin >> n;
    g.resize(n), ans.resize(n), a.resize(n), b.resize(n);

    for (int i = 0; i < n; ++i) {
        int p; cin >> p >> a[i] >> b[i];
        --p;

        if (p >= 0) {
            g[p].push_back(i);
            g[i].push_back(p);
        }
    }

    dfs(0);
    for (auto i : ans) cout << i << "\n";

    return 0;
}