#include <iostream>
#include <set>
#include <string>
#include <vector>
#include <map>
#include <math.h>
#include <algorithm>
using namespace std;

vector <pair <int, int>> h;
vector <vector <int>> g;
vector <set<pair <int, int>>> dp;

void dfs(int v) {
    for (auto x : g[v])
        dfs(x);
    for (int a = 1; a <= h[v].first; ++a) {
        for (int b = 1; b <= h[v].second; ++b) {
            dp[v].insert(make_pair(a, b));
        }
    }
    for (auto x : g[v]) {
        for (auto y : dp[x]) {
            dp[v].insert(y);
        }
    }
}

int main()
{
    int n;
    cin >> n;
    h.resize(n);
    g.resize(n);
    dp.resize(n);
    for (int i = 0; i < n; ++i) {
        int p, a, b;
        cin >> p >> a >> b;
        --p;
        if (p > -1) {
            g[p].push_back(i);
        }
        h[i] = make_pair(a, b);
    }
    dfs(0);
    for (int i = 0; i < n; ++i) {
        cout << dp[i].size() << '\n';
    }
}