#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <algorithm>
#include <cmath>
#include <string>
#include <sstream>
#include <vector>
#include <stack>
#include <queue>
#include <deque>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <iomanip>
#include <functional>
#include <limits>
#include <ctime>
#include <cassert>

#define pb push_back
#define mp make_pair
#define endl '\n'
#define sqr(x) ((x) * (x))
#define IOboost ios_base::sync_with_stdio(false); cin.tie(NULL)
#ifndef _getchar_nolock
#define _putchar_nolock putchar_unlocked
#define _getchar_nolock getchar_unlocked
#endif
#define int ll

#pragma warning (disable : 4996)
#pragma optimize ("gtsy", on)
//#pragma comment(linker, "/STACK:536870912")

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair <int, int> pii;
typedef vector <int> vi;
typedef vector <vi> vvi;
typedef vector <pii> vii;
typedef vector <char> vc;

const ld EPS = 1e-8;
const int N = (int)1e5 + 10;
const int INF = (int)2e9;
const int MOD = (int)1e9 + 7;

pii cross(pii a, pii b) {
	if (b.first >= 0 || (b.first < 0 && a.first < b.first))
		swap(a, b);
	if (a == b)
		return a;
	if (a.first == b.first || (a.first >= 0 && b.first >= 0))
		return { -5, 0 };
	int x, y;
	if (a.first >= 0) {
		x = a.first;
		y = a.second;
		if (b.first == -1 && x != b.second)
			return { -5, 0 };
		if (b.first == -2 && y != b.second)
			return { -5, 0 };
		if (b.first == -3 && x - y != b.second)
			return { -5, 0 };
		if (b.first == -4 && x + y != b.second)
			return { -5, 0 };
		return { x, y };
	}
	if (a.first == -1) {
		x = a.second;
		if (b.first == -2)
			y = b.second;
		if (b.first == -3)
			y = x - b.second;
		if (b.first == -4)
			y = b.second - x;
		if (x >= 0 && y >= 0)
			return { x, y };
		else
			return { -5, 0 };
	}
	if (a.first == -2) {
		y = a.second;
		if (b.first == -3)
			x = b.second + y;
		else
			x = b.second - y;
		if (x >= 0 && y >= 0)
			return { x, y };
		else
			return { -5, 0 };
	}
	if ((a.second + b.second) % 2)
		return { -5, 0 };
	x = (a.second + b.second) / 2;
	y = b.second - x;
	if (x >= 0 && y >= 0)
		return { x, y };
	else
		return { -5, 0 };
}

#ifdef LOCAL
#define STRESS
#define STRESS_GEN
#endif

int slow(int m, int n, vii f) {
	vvi a(m, vi(m));
	for (int i = 0; i < n; ++i) {
		int x = f[i].first, y = f[i].second;
		for (int x1 = 0; x1 < m; ++x1) {
			if (abs(x1 - x) <= 1)
				continue;
			a[x1][y]++;
			if (x + y - x1 >= 0 && x + y - x1 < m)
				a[x1][x + y - x1]++;
			if (x1 - x + y >= 0 && x1 - x + y < m)
				a[x1][x1 - x + y]++;
		}
		for (int y1 = 0; y1 < m; ++y1) {
			if (abs(y1 - y) <= 1)
				continue;
			a[x][y1]++;
		}
	}
	int ans = 0;
	for (int i = 0; i < m; ++i) {
		for (int j = 0; j < m; ++j) {
			if (a[i][j] == n)
				++ans;
		}
	}
	return ans;
}

void solve() {
	int m, n;
#ifdef STRESS_GEN
	m = rand() % 10 + 1;
	n = rand() % min(10LL, m * m) + 1;
#else
	cin >> m >> n;
#endif
	vii a;
	vii f;
	for (int i = 0; i < n; ++i) {
		int x, y;
#ifdef STRESS_GEN
		x = rand() % m;
		y = rand() % m;
#else
		cin >> x >> y;
		--x; --y;
#endif
		vii b = { {-1, x}, {-2, y}, {-3, x - y}, {-4, x + y} };
		if (!i)
			a = b;
		else {
			vii c;
			for (int j = 0; j < a.size(); ++j) {
				for (int k = 0; k < b.size(); ++k) {
					pii p = cross(a[j], b[k]);
					if (p.first != -5 && p != mp(x, y))
						c.push_back(p);
				}
			}
			a = c;
		}
		f.push_back({ x, y });
	}
	int ans = 0;
	for (auto p : a) {
		if (p.first >= 0) {
			bool flag = 1;
			for (int i = 0; i < n; ++i) {
				if (abs(p.first - f[i].first) <= 1 && abs(p.second - f[i].second) <= 1) {
					flag = 0;
					break;
				}
			}
			if (flag && p.first < m && p.second < m)
				++ans;
		}
		else if (p.first == -1) {
			vi r;
			for (int i = 0; i < n; ++i) {
				if (f[i].first == p.second)
					r.push_back(f[i].second);
			}
			sort(r.begin(), r.end());
			if (r.empty())
				continue;
			if (r[0] - 1 > 0)
				ans += r[0] - 1;
			if (r.back() + 1 < m - 1)
				ans += m - 2 - r.back();
			for (int i = 0; i < r.size() - 1; ++i) {
				if (r[i] + 1 < r[i + 1] - 1)
					ans += r[i + 1] - r[i] - 3;
			}
		}
		else if (p.first == -2) {
			vi r;
			for (int i = 0; i < n; ++i) {
				if (f[i].second == p.second)
					r.push_back(f[i].first);
			}
			sort(r.begin(), r.end());
			if (r.empty())
				continue;
			if (r[0] - 1 > 0)
				ans += r[0] - 1;
			if (r.back() + 1 < m - 1)
				ans += m - 2 - r.back();
			for (int i = 0; i < r.size() - 1; ++i) {
				if (r[i] + 1 < r[i + 1] - 1)
					ans += r[i + 1] - r[i] - 3;
			}
		}
		else if (p.first == -3) {
			vi r;
			for (int i = 0; i < n; ++i) {
				if (f[i].first - f[i].second == p.second)
					r.push_back(f[i].first);
			}
			sort(r.begin(), r.end());
			if (r.empty())
				continue;
			if (r[0] - 1 > max(p.second, 0LL))
				ans += r[0] - 1 - max(p.second, 0LL);
			if (r.back() + 1 < min(m - 1, p.second + m - 1))
				ans += min(m - 1, p.second + m - 1) - r.back() - 1;
			for (int i = 0; i < r.size() - 1; ++i) {
				if (r[i] + 1 < r[i + 1] - 1)
					ans += r[i + 1] - r[i] - 3;
			}
		}
		else {
			vi r;
			for (int i = 0; i < n; ++i) {
				if (f[i].first + f[i].second == p.second)
					r.push_back(f[i].first);
			}
			sort(r.begin(), r.end());
			if (r.empty())
				continue;
			if (r[0] - 1 > max(p.second - m + 1, 0LL))
				ans += r[0] - 1 - max(p.second - m + 1, 0LL);
			if (r.back() + 1 < min(m - 1, p.second))
				ans += min(m - 1, p.second) - r.back() - 1;
			for (int i = 0; i < r.size() - 1; ++i) {
				if (r[i] + 1 < r[i + 1] - 1)
					ans += r[i + 1] - r[i] - 3;
			}
		}
	}
#ifdef STRESS_GEN
	int ans1 = slow(m, n, f);
	if (ans1 != ans)
		cout << ans1 << ' ' << ans << endl;
#else
#ifdef STRESS
	cout << slow(m, n, f) << ' ';
#endif
	cout << ans << endl;
#endif
	return;
}


signed main() {
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	IOboost;

#ifdef STRESS_GEN
	for(int it = 0; it < 100; ++it)
#else
	int t;
	cin >> t;
	for (int q = 0; q < t; ++q)
#endif
		solve();

	return 0;
}