#include <bits/stdc++.h>

#define all(x) (x).begin(), (x).end()

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

const int INF = 1e9;
const ll INFF = 1e18;

map<string, set<string>> g;
map<string, int> used;
string ans = "";
bool ok = false;
bool bad = false;

void dfs(string v) {
	if (ok || bad) return;
	used[v] = 1;
	if (g[v].empty()) {
		ans = v;
		ok = true;
		return;
	}
	if (g[v].size() > 1) {
		cout << "TOO COMPLEX\n";
		bad = true;
		return;
	}
	for (string u : g[v]) {
		if (u == v) {
			ans = v;
			ok = true;
			return;
		}
		else if (used[u] == 1) {
			cout << "INFINITE LOOP\n";
			bad = true;
			return;
		}
		else if (used[u] == 0) {
			dfs(u);
		}
	}
	used[v] = 2;
}

int main() {
		ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	int n, q;
	cin >> n;
	for (int i = 0; i < n; i++) {
		string a, b, c;
		cin >> a >> b >> c;
		g[a].insert(c);
	}
	cin >> q;
	while (q--) {
		char t;
		cin >> t;
		if (t == '+') {
			string a, b, c;
			cin >> a >> b >> c;
			g[a].insert(c);
		}
		else {
			for (auto &it:used) it.second = 0;
			string a; cin >> a;
			ok = bad = false;
			dfs(a);
			if (ok) cout << ans << '\n';
		}
	}
}