#include "iostream"
#include "vector"
#include "algorithm"

#define ll long long

using namespace std;

void solve()
{
	ll m, n;
	cin >> m >> n;

	vector<pair<int, int>> a(n);
	for (int i = 0; i < n; i++)
		cin >> a[i].first >> a[i].second;

	if (n == 1)
	{
		cout << 4 * (m - 3) << '\n';
		return;
	}

	if (m < 100)
	{
		int ans = 0;
		for (int y = 1; y <= m; y++)
		{
			for (int x = 1; x <= m; x++)
			{
				bool f = true;
				for (int i = 0; i < n && f; i++)
				{
					f &= (x == a[i].first) || 
						(y == a[i].second) || 
						(abs(x - a[i].first) == abs(y - a[i].second));
				}
				ans += f;
			}
		}

		cout << ans << '\n';
	}
}

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie();
	cout.tie();

	int t;
	cin >> t;
	while (t--)
		solve();

	return 0;
}