#include "iostream"
#include "vector"
#include "algorithm"

using namespace std;

#define ll long long

ll gcd(ll a, ll b)
{
	if (!b)
		return a;
	return gcd(b, a % b);
}

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie();
	cout.tie();

	int n;
	cin >> n;
	vector<int> a;
	for (int i = 0; i < n; i++)
	{
		int x;
		cin >> x;
		a.push_back(x + 1);
	}
	
	vector<ll> c = { a[0] };
	int f = n - 1;
	for (int i = 1; i < n; i++)
	{
		

		c.push_back(c[i - 1] * a[i] / gcd(c[i - 1], a[i]));

		if (c[i] > 1e7)
		{
			f = i;
			break;
		}
	}

	int q;
	cin >> q;
	for (int i = 0; i < q; i++)
	{
		int x;
		cin >> x;
		x--;

		if (x % c[f] == 0)
		{
			cout << -1 << '\n';
			continue;
		}

		int l = -1, r = f - 1;
		while (l + 1 < r)
		{
			int m = (l + r) / 2;
			if (x % c[m] != 0)
				r = m;
			else
				l = m;
		}

		cout << r + 1 << '\n';
	}

	return 0;
}