#pragma gcc optimize("Ofast,no-stack-protector,tune=native")
#pragma gcc optimize("sse,sse2,sse3,sse4,ssse3")
#pragma gcc optimize("abm,mmx,avx,avx2,unroll-loops,fast-math,section-anchors")

#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const ll INF = (ll)(1e18);
const ll MOD = (ll)(1e9 + 7);
const ld EPS = (ld)(1e-18);

void fast_stream() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    //cout << fixed << setprecision(30);
}

map<string, ll> stroka_versh;
map<ll, string> versh_stroka;
vector<set<ll>> g;
vector<ll> used;
map<ll, ll> cam_soboi;

string dfs(ll v) {
    if (g[v].size() >= 2) {
        return "TOO COMPLEX";
    }
    if (g[v].size() == 0) {
        return versh_stroka[v];
    }
    if (g[v].size() == 1 && *g[v].begin() == v) {
        return versh_stroka[v];
    }
    if (used[v]) {
        return "INFINITE LOOP";
    }
    used[v] = 1LL;
    string ans = dfs(*g[v].begin());
    return ans;
}

signed main() {
    fast_stream();
    //freopen("avia.in", "r", stdin);
    //freopen("avia.out", "w", stdout);
    ll n;
    cin >> n;
    ll ind = 0LL;
    map<string, set<string>> df;
    map<string, string> where;
    for (ll i = 0; i < n; ++i) {
        string a, b, c;
        cin >> a >> b >> c;
        // if (a == c) continue;
        if (a != c) {
            df[c].insert(a);
            where[a] = c;
            for (auto kh : df[a]) {
                df[c].insert(kh);
                where[kh] = c;
            }
            df[a].clear();
        }
        if (stroka_versh.find(a) == stroka_versh.end()) {
            stroka_versh[a] = ind;
            versh_stroka[ind] = a;
            ++ind;
            g.push_back({});
        }
        if (stroka_versh.find(c) == stroka_versh.end()) {
            stroka_versh[c] = ind;
            versh_stroka[ind] = c;
            ++ind;
            g.push_back({});
        }
        ll v1 = stroka_versh[a];
        ll v2 = stroka_versh[c];
        g[v1].insert(v2);
    }
    ll tests;
    cin >> tests;
    if (max(n, tests) > 1000) {
        while (tests--) {
            char t;
            cin >> t;
            if (t == '+') {
                string a, b, c;
                cin >> a >> b >> c;
                if (a == c) continue;        
                df[c].insert(a);
                where[a] = c;
                for (auto kh : df[a]) {
                    df[c].insert(kh);
                    where[kh] = c;
                }
                df[a].clear();
            }
            else {
                string h;
                cin >> h;
                cout << where[h] << '\n';
            }
        }
        return 0;
    }
    while (tests--) {
        char t;
        cin >> t;
        if (t == '+') {
            string a, b, c;
            cin >> a >> b >> c;
            // if (a == c) continue;
            if (stroka_versh.find(a) == stroka_versh.end()) {
                stroka_versh[a] = ind;
                versh_stroka[ind] = a;
                ++ind;
                g.push_back({});
            }
            if (stroka_versh.find(c) == stroka_versh.end()) {
                stroka_versh[c] = ind;
                versh_stroka[ind] = c;
                ++ind;
                g.push_back({});
            }
            ll v1 = stroka_versh[a];
            ll v2 = stroka_versh[c];
            g[v1].insert(v2);
        }
        else {
            used.assign(g.size(), 0LL);
            string f;
            cin >> f;
            if (stroka_versh.find(f) == stroka_versh.end()) {
                cout << f << '\n';
                continue;
            }
            cout << dfs(stroka_versh[f]) << '\n';
        }
    }
}