#pragma gcc optimize("Ofast,no-stack-protector,tune=native")
#pragma gcc optimize("sse,sse2,sse3,sse4,ssse3")
#pragma gcc optimize("abm,mmx,avx,avx2,unroll-loops,fast-math,section-anchors")

#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const ll INF = (ll)(1e18);
const ll MOD = (ll)(1e9 + 7);
const ld EPS = (ld)(1e-18);

void fast_stream() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    //cout << fixed << setprecision(30);
}

signed main() {
    fast_stream();
    //freopen("avia.in", "r", stdin);
    //freopen("avia.out", "w", stdout);
    ll tests;
    cin >> tests;
    while (tests--) {
        ll n, m;
        cin >> n >> m;
        set<pair<ll, ll>> h;
        for (ll i = 0; i < m; ++i) {
            ll x, y;
            cin >> x >> y;
            set<pair<ll, ll>> tr;
            for (ll i = 1; i < x - 1; ++i) {
                tr.insert({i, y});
                // cout << i << ' ' << y << '\n';
            }
            for (ll i = x + 2; i <= n; ++i) {
                tr.insert({i, y});
            }
            for (ll j = 1; j < y - 1; ++j) {
                tr.insert({x, j});
            }
            for (ll j = y + 2; j <= n; ++j) {
                tr.insert({x, j});
            }
            for (ll i = 0; i < min(x, y) - 2; ++i) {
                tr.insert({x - 2 - i, y - 2 - i});
            }
            for (ll i = 0; i < n - max(x, y) - 1; ++i) {
                tr.insert({x + 2 + i, y + 2 + i});
            }
            for (ll i = 0; i < min(x - 1, n - y) - 1; ++i) {
                tr.insert({x - 2 - i, y + 2 + i});
            }
            for (ll i = 0; i < min(n - x, y - 1) - 1; ++i) {
                tr.insert({x + 2 + i, y - 2 - i});
            }
            if (i == 0) {
                h = tr;
            }
            else {
                set<pair<ll, ll>> r;
                for (auto i : tr) {
                    if (h.find(i) != h.end()) {
                        r.insert(i);
                    }
                }
                h = r;
            }
        }
        cout << h.size() << '\n';
    }
}