﻿#include <algorithm>
#include <iostream>
#include <vector>
#include <cmath>
#include <set>

using namespace std;

int solve()
{
	long long n;
	cin >> n;
	if (n == 1)
		return 1;
	long long left = 1, right = 1e10;
	while (left + 1 < right)
	{
		long long mid = (left + right) >> 1;
		long long end = 2 * ((mid - 1) * (mid + 2) / 2) + 1;
		long long start = end - 2 * mid + 1;
		if (n >= start && n <= end)
		{
			int d = (end - start) / 2;
			if (start + d < n)
				return 2 * (mid - 1) + 1;
			else
				return 2 * (mid - 1);
		}
		else if (n < start)
			right = mid;
		else
			left = mid;
	}
}

int main()
{
	int q;
	cin >> q;
	vector < int > ans(q);
	for (int i = 0; i < q; i++)
		ans[i] = solve();
	for (auto out : ans)
		cout << out << endl;

	return 0;
}