#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdio>
#include <vector>
#include <set>
#include <cmath>
#include <algorithm>
#include <cassert>
#include <map>
using namespace std;
#define sz(a) int(a.size())
#define pb push_back
#define mp make_pair
#define forn(i, e, n) for(int i = e; i < int(n); i++)
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pt;
const int MAXN = 1e3 + 100;

int tab[MAXN][MAXN];
int x = 0, y = 0;
int key = 0;
int h, w, d1;

void l() {
    int cnt = 0;
    while (y - 1 >= 0) {
        if (tab[x][y - 1] == 1) break;
        if (tab[x][y - 1] == 3) {
            if (key == 0) break;
            key--;
        }
        if (tab[x][y - 1] == 2)
            key++;
        y--;
        cnt++;
    }
    cout << cnt << '\n';
}

void r() {
    int cnt = 0;
    while (y + 1 < w) {
        if (tab[x][y + 1] == 1) break;
        if (tab[x][y + 1] == 3) {
            if (key == 0) break;
            key--;
        }
        if (tab[x][y + 1] == 2)
            key++;
        y++;
        cnt++;
    }
    cout << cnt << '\n';
}

void up() {
    int cnt = 0;
    while (x - 1 >= 0) {
        if (tab[x - 1][y] == 1) break;
        if (tab[x - 1][y] == 3) {
            if (key == 0) break;
            key--;
        }
        if (tab[x - 1][y] == 2)
            key++;
        x--;
        cnt++;
    }
    cout << cnt << '\n';
}

void d() {
    int cnt = 0;
    while (x + 1 < h) {
        if (tab[x + 1][y] == 1) break;
        if (tab[x + 1][y] == 3) {
            if (key == 0) break;
            key--;
        }
        if (tab[x + 1][y] == 2)
            key++;
        x++;
        cnt++;
    }
    cout << cnt << '\n';
}

int main()
{
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // _DEBUG
    cin >> h >> w >> d1;
    forn(i, 0, h) {
        forn(j, 0, w) {
            char c;
            cin >> c;
            if (c == '.') tab[i][j] = 0;
            if (c == '#') tab[i][j] = 1;
            if (c == 'K') tab[i][j] = 2;
            if (c == 'L') tab[i][j] = 3;
            if (c == 'S') {
                tab[i][j] = 0;
                x = i;
                y = j;
            }
        }
    }
    int L;
    cin >> L;
    string s;
    cin >> s;
    forn(i, 0, L) {
        char c;
        c = s[i];
        if (c == 'U')
            up();
        if (c == 'R')
            r();
        if (c == 'D')
            d();
        if (c == 'L')
            l();
    }
    return 0;
}

