#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdio>
#include <vector>
#include <set>
#include <cmath>
#include <algorithm>
#include <map>
using namespace std;
#define sz(a) int(a.size())
#define pb push_back
#define mp make_pair
#define forn(i, e, n) for(int i = e; i < int(n); i++)
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pt;
const int MAXN = 1e5 + 100;
const int R = 1e6 + 100;

vector<int> gr[MAXN];
int a[MAXN];
int b[MAXN];
ll ans[MAXN];

void merge(map<int, int>&a, const map<int, int>& b) {
    for (auto i : b) {
        int x = i.first;
        int y = i.second;
        a[x] = max(a[x], y);
    }
}

ll getans(map<int, int>& a) {
    map<int, int> t;
    ll now = 0;
    ll nowx = 0, nowy = 0;
    vector<int> del;
    for(auto i : a) {
        int x = R - i.first;
        int y = i.second;
        if (nowx == 0) {
            nowx = x;
            nowy = y;
            continue;
        }
        if (y > nowy) {
            t[R - nowx] = nowy;
            now += (nowx - x) * 1LL * nowy;
            nowx = x;
            nowy = y;
        }
        else
            del.push_back(x);
    }
    now += nowx * 1LL * nowy;
    t[R - nowx] = nowy;
    a = t;
    return now;
}

map<int, int> dfs(int v) {
    map<int, int> now;
    now[R - a[v]] = b[v];
    for (int to : gr[v]) {
        map<int, int> w = dfs(to);
        if (sz(w) < sz(now))
            swap(now, w);
        merge(now, w);
    }
    ans[v] = getans(now);
    return now;
}

int main()
{
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // _DEBUG
    int n;
    cin >> n;
    forn(i, 0, n) {
        int q;
        cin >> q;
        gr[q].push_back(i + 1);
        cin >> a[i + 1] >> b[i + 1];
    }
    dfs(0);
    forn(i, 0, n)
        cout << ans[i + 1] << '\n';
    map<int, int> t;
    return 0;
}

